//--------------------------------------------------------------------//
// xi[Z

var viewModel;		// \f
var model;		// \iqL̐ϖ@f[^f
var bounds;		// fE
var boundsEdge;		// fE
var sectionGrid;	// ffʊiq
var sectionPoint;	// ffʂ̊iq_
var contour;		// R^[}
var cContext;		// R^[}pReLXg
var cImage;		// R^[}p摜f[^
var velVector;		// xxNg
var result;		// \錋ʃf[^
var dMax,dMin;		// f[^̍őlEŏl
var step;		// ^CXebv
var running;		// vZsXCb`

// E
var NONE=0;		// Eݒ薳
var SLIP=1;		// 
var WALL=2;		// Ǐ
var INLET=3;		// 
var OUTLET=4;		// o
var PERIODIC=5;		// E
var INSULATE=2;		// fM
var FIX=4;		// Œ

// xxNg\CC
var VECTOR_SIZE=0.0025,HEAD_L=0.25*VECTOR_SIZE,HEAD_W=0.6*HEAD_L;
// xxNgŏ
var MIN_VELOCITY=1e-8;
// Eӕ\FCfʊiq\FCxxNg\F
var EDGE_COLOR=0xcccccc,GRID_COLOR=0x999999,VEL_COLOR=0xffffff;
// R^[}`pLoX̕E
var CANVAS_WIDTH=256,CANVAS_HEIGHT=256;

// f[^
function initModel(){
  document.addEventListener('keydown',keyPressed,false);
  model=new FVMDataModel();
  sectionGrid=null;
  contour=null;
  velVector=null;
  result=0;
  dMax=0;
  dMin=0;
  createBenard();
  initThree();
  initObject();
  loop();
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 88:		// X
      viewModel.viewX();
      break;
    case 89:		// Y
      viewModel.viewY();
      break;
    case 90:		// Z
      viewModel.viewZ();
      break;
  }
}

// three.js ̏
function initThree(){
  viewModel=new ViewModel('cfd-canvas');
  result=document.getElementById('contour').selectedIndex;
}

// \IuWFNg
function initObject(){
  setBorderEdges();
  setSectionGrid();
  viewModel.setAxis();
}

// Eӂݒ肷
function setBorderEdges(){
  var edges=[],i,gr=model.grid,grid=gr.grid,gr1,gr2;
  var x=gr.nx-1,y=gr.ny-1,z=gr.nz-1;
  for(i=0;i<12;i++) edges[i]=new THREE.Geometry();
  for(i=0;i<=x;i++){
    gr1=grid[i];
    edges[0].vertices[i]=gr1[0][0];
    edges[1].vertices[i]=gr1[y][0];
    edges[2].vertices[i]=gr1[0][z];
    edges[3].vertices[i]=gr1[y][z];
  }
  gr1=grid[0];
  gr2=grid[x];
  for(i=0;i<=y;i++){
    edges[4].vertices[i]=gr1[i][0];
    edges[5].vertices[i]=gr2[i][0];
    edges[6].vertices[i]=gr1[i][z];
    edges[7].vertices[i]=gr2[i][z];
  }
  gr1=grid[0][0];
  gr2=grid[x][0];
  var gr3=grid[0][y],gr4=grid[x][y];
  for(i=0;i<=z;i++){
    edges[8].vertices[i]=gr1[i];
    edges[9].vertices[i]=gr2[i];
    edges[10].vertices[i]=gr3[i];
    edges[11].vertices[i]=gr4[i];
  }
  var edgeMat=new THREE.LineBasicMaterial({color:EDGE_COLOR});
  boundsEdge=new THREE.Group();
  for(i=0;i<12;i++){
    boundsEdge.add(new THREE.Line(edges[i],edgeMat));
  }
  viewModel.addObject(boundsEdge);
}

// fʊiqݒ肷
function setSectionGrid(){
  var i,j,edges=[];
  if(sectionGrid!==null){
    viewModel.removeObject(sectionGrid);
    for(i=0;i<sectionGrid.children.length;i++){
      sectionGrid.children[i].geometry.dispose();
      sectionGrid.children[i].material.dispose();
    }
  }
  sectionPoint=model.getSectionGrid();
  var nx=sectionPoint.length,ny=sectionPoint[0].length;
  for(i=0;i<nx+ny;i++){
    edges[i]=new THREE.Geometry();
  }
  for(i=0;i<nx;i++){
    for(j=0;j<ny;j++){
      edges[i].vertices[j]=sectionPoint[i][j];
      edges[nx+j].vertices[i]=sectionPoint[i][j];
    }
  }
  sectionGrid=new THREE.Group();
  var lineMat=new THREE.LineBasicMaterial({color:GRID_COLOR});
  for(i=0;i<nx+ny;i++){
    sectionGrid.add(new THREE.Line(edges[i],lineMat));
  }
  viewModel.addObject(sectionGrid);
  setContour();
}

// R^[}ݒ肷
function setContour(){
  if(contour!==null){
    viewModel.removeObject(contour);
    contour.geometry.dispose();
    contour.material.map.dispose();
    contour.material.dispose();
  }
  switch(result){
    case 0:
      contour=null;
      dMax=0;
      dMin=0;
      break;
    case 1:
      createContour(model.getSectionPressure());
      break;
    case 2:
      createContour(model.getSectionTemperature());
      break;
  }
  createVelocityVector();
  showInfo();
}

// R^[}XV
function updateContour(){
  switch(result){
    case 1:
      drawContourImage(model.getSectionPressure());
      contour.material.map.version++;
      break;
    case 2:
      drawContourImage(model.getSectionTemperature());
      contour.material.map.version++;
      break;
  }
  updateVelocityVector();
  showInfo();
}

// R^[}쐬
// data - R^[f[^
function createContour(data){
  var canvas=document.createElement('canvas');
  canvas.width=CANVAS_WIDTH;
  canvas.height=CANVAS_HEIGHT;
  cContext=canvas.getContext('2d');
  cImage=cContext.createImageData(CANVAS_WIDTH,CANVAS_HEIGHT);
  drawContourImage(data);
  var texture=new THREE.Texture(canvas);
  texture.needsUpdate=true;
  var geometry=new THREE.ParametricGeometry
    (sectionInterPoint,data.length,data[0].length);
  var material=new THREE.MeshBasicMaterial
    ({map:texture,transparent:true,opacity:0.7,side:THREE.DoubleSide});
  contour=new THREE.Mesh(geometry,material);
  viewModel.addObject(contour);
}

// R^[}p摜`悷
// data - R^[f[^
function drawContourImage(data){
  var nx=data.length,ny=data[0].length,i,j;
  dMin=data[0][0];
  dMax=data[0][0];
  for(i=0;i<nx;i++){
    for(j=0;j<ny;j++){
      dMin=Math.min(dMin,data[i][j]);
      dMax=Math.max(dMax,data[i][j]);
    }
  }
  var di=1/(dMax-dMin);
  var cx=(nx-1)/(CANVAS_WIDTH-1),cy=(ny-1)/(CANVAS_HEIGHT-1);
  var index=0;
  var bitmapData=cImage.data;
  for(j=0;j<CANVAS_HEIGHT;j++){
    var y=ny-1-cy*j;
    var iy=parseInt(y),t=y-iy,iyp=Math.min(iy+1,ny-1);
    for(i=0;i<CANVAS_WIDTH;i++){
      var x=cx*i;
      var ix=parseInt(x),s=x-ix,ixp=Math.min(ix+1,nx-1);
      var val=(1-s)*((1-t)*data[ix][iy]+t*data[ix][iyp])+
      	      s*((1-t)*data[ixp][iy]+t*data[ixp][iyp]);
      val=di*(val-dMin);
      colorBar(bitmapData,index,val);
      index+=4;
    }
  }
  cContext.putImageData(cImage,0,0);
}

// fʊiq̓_Ԃ
// u,v - Ȗʏ̃p[^
function sectionInterPoint(u,v){
  var nx=sectionPoint.length-1,ny=sectionPoint[0].length-1;
  var x=nx*u,ix=parseInt(x),s=x-ix;
  var y=ny*v,iy=parseInt(y),t=y-iy;
  var ixp=Math.min(ix+1,nx),iyp=Math.min(iy+1,ny);
  var p1=sectionPoint[ix][iy],p2=sectionPoint[ix][iyp];
  var p3=sectionPoint[ixp][iy],p4=sectionPoint[ixp][iyp];
  return new THREE.Vector3
    ((1-s)*((1-t)*p1.x+t*p2.x)+s*((1-t)*p3.x+t*p4.x),
     (1-s)*((1-t)*p1.y+t*p2.y)+s*((1-t)*p3.y+t*p4.y),
     (1-s)*((1-t)*p1.z+t*p2.z)+s*((1-t)*p3.z+t*p4.z));
}

// J[o[ݒ肷
// bitmapData - rbg}bvf[^
// index - f[^JnCfbNX
// z - f[^i0`1j
function colorBar(bitmapData,index,z){
//  var COLOR_STEP=10;
//  z=Math.round(COLOR_STEP*z)/COLOR_STEP;
  if(z<=0){
    bitmapData[index]=0;
    bitmapData[index+1]=0;
    bitmapData[index+2]=255;
  }
  else if(z<0.25){
    bitmapData[index]=0;
    bitmapData[index+1]=parseInt(1020*z);
    bitmapData[index+2]=255;
  }
  else if(z<0.5){
    bitmapData[index]=0;
    bitmapData[index+1]=225+parseInt(120*(0.5-z));
    bitmapData[index+2]=parseInt(1020*(0.5-z));
  }
  else if(z<0.75){
    bitmapData[index]=parseInt(1020*(z-0.5));
    bitmapData[index+1]=225+parseInt(120*(z-0.5));
    bitmapData[index+2]=0;
  }
  else if(z<1){
    bitmapData[index]=255;
    bitmapData[index+1]=parseInt(1020*(1-z));
    bitmapData[index+2]=0;
  }
  else{
    bitmapData[index]=255;
    bitmapData[index+1]=0;
    bitmapData[index+2]=0;
  }
  bitmapData[index+3]=255;
}

// xxNg쐬
function createVelocityVector(){
  if(velVector!==null){
    viewModel.removeObject(velVector);
    for(i=velVector.children.length-1;i>=0;i--){
      velVector.children[i].line.geometry.dispose();
      velVector.children[i].line.material.dispose();
      velVector.children[i].cone.geometry.dispose();
      velVector.children[i].cone.material.dispose();
      velVector.remove(velVector.children[i]);
    }
  }
  var u=model.getSectionV();
  var coef=VECTOR_SIZE/Math.max(model.getMaxV(),MIN_VELOCITY);
  velVector=new THREE.Group();
  for(var i=0;i<sectionPoint.length-1;i++){
    for(var j=0;j<sectionPoint[i].length;j++){
      var l=u[i][j].length(),dir;
      if(l<=MIN_VELOCITY){
      	dir=new THREE.Vector3(0,0,1);
      }
      else{
      	dir=u[i][j].clone().normalize();
      }
// ̒0ȉƃG[ɂȂ邽ߏC
      l=Math.max(coef*l,MIN_VELOCITY+HEAD_L);
      var arrow=new THREE.ArrowHelper
      	(dir,sectionPoint[i][j],l,VEL_COLOR,HEAD_L,HEAD_W);
      velVector.add(arrow);
    }
  }
  viewModel.addObject(velVector);
}

// xxNgXV
function updateVelocityVector(){
  var u=model.getSectionV(),ii=0;
  var coef=VECTOR_SIZE/Math.max(model.getMaxV(),MIN_VELOCITY);
  for(var i=0;i<sectionPoint.length-1;i++){
    for(var j=0;j<sectionPoint[i].length;j++){
      var l=u[i][j].length(),dir;
      if(l<=MIN_VELOCITY){
      	dir=new THREE.Vector3(0,0,1);
      }
      else{
      	dir=u[i][j].clone().normalize();
      }
// ̒0ȉƃG[ɂȂ邽ߏC
      l=Math.max(coef*l,MIN_VELOCITY+HEAD_L);
      var arrow=velVector.children[ii];
      arrow.setDirection(dir);
      arrow.setLength(l,HEAD_L,HEAD_W);
      ii++;
    }
  }
}

// [v֐
function loop(){
  viewModel.update();
  if(running){
    step++;
    if(model.param.isFinished()){
      running=false;
    }
    else{
      model.nextStep();
    }
    updateContour();
  }
  showInfo();
  requestAnimationFrame(loop);
}

// \
function showInfo(){
  document.getElementById('step').textContent=model.param.iteration();
  document.getElementById('max').textContent=dMax.toExponential(3);
  document.getElementById('min').textContent=dMin.toExponential(3);
}

// vZJn
function calcStart(){
  running=true;
  setContour();
}

// vZ𒆒f
function calcStop(){
  running=false;
}

// vZԂɖ߂
function calcInit(){
  running=false;
  step=0;
  setBenardField();
  model.param.init();
  setContour();
}

// R^[}I
function selectContour(){
  result=document.getElementById('contour').selectedIndex;
  setContour();
}

// fʂI
function selectSection(){
  var sect=document.getElementById('section').selectedIndex;
  var range=document.getElementById('secrange');
  var rmax=[model.grid.nz-1,model.grid.nx-1,model.grid.ny-1];
  range.max=rmax[sect];
  model.setSection(sect);
  range.value=Math.max(model.section.z,model.section.x,model.section.y);
  setSectionGrid();
}

// fʂړ
function moveSection(){
  var p=parseInt(document.getElementById('secrange').value);
  if(model.section.x>=0){
    model.section.x=p;
  }
  else if(model.section.y>=0){
    model.section.y=p;
  }
  else if(model.section.z>=0){
    model.section.z=p;
  }
  setSectionGrid();
}

//--------------------------------------------------------------------//
// f쐬

// xi[Z쐬
function createBenard(){
  var nx=31,ny=31,nz=12,xs=0.05,ys=0.05,zs=0.01;
  var dx=xs/(nx-1),dy=ys/(ny-1);
  var s0=2/(nz-1),a=1.5,b=(a+1)/(a-1),cf=zs/(b-1);
  var grid=[],z=[],i,j,k;

  model.param.set(1,500);

  z[0]=0;
  for(k=1;k<nz;k++){
    var sk=s0*k;
    z[k]=cf*(Math.pow(b,sk)-1)/(Math.pow(b,sk-1)+1);
  }
  for(i=0;i<nx;i++){
    var x=dx*i;
    grid[i]=[];
    for(j=0;j<ny;j++){
      var y=dy*j;
      grid[i][j]=[];
      for(k=0;k<nz;k++){
      	grid[i][j][k]=new THREE.Vector3(x,y,z[k]);
      }
    }
  }
  bounds=new Bounds(0,xs,0,ys,0,zs);

  var flowBc=createBC(nx,ny,nz);
  var heatBc=createBC(nx,ny,nz);
  setBcXm(flowBc,PERIODIC);
  setBcXp(flowBc,PERIODIC);
  setBcYm(flowBc,PERIODIC);
  setBcYp(flowBc,PERIODIC);
  setBcZm(flowBc,WALL);
  setBcZp(flowBc,WALL);
  setBcXm(heatBc,PERIODIC);
  setBcXp(heatBc,PERIODIC);
  setBcYm(heatBc,PERIODIC);
  setBcYp(heatBc,PERIODIC);
  setBcZm(heatBc,FIX);
  setBcZp(heatBc,FIX);

  model.param.setMaterial(1000,1e-3,2e-4,0.594,4200);
  model.grid.setGrid(nx,ny,nz,grid,flowBc);
  model.setBC(flowBc,heatBc);
  model.setGridData();

  document.getElementById('section').selectedIndex=0;
  document.getElementById('secrange').max=nz-1;
  document.getElementById('secrange').value=model.section.z;
  setBenardField();
}

// xi[Z̃p[^zݒ肷
// model - \iqL̐ϖ@f[^f
function setBenardField(){
  var h=0.01,grav=9.8,ra=20000,para=model.param;
  var tHeat=ra*para.alpha*para.kvis/(para.beta*grav*h*h*h);
  var u=[],v=[],w=[],p=[],t=[];
  for(var i=0;i<model.grid.nx;i++){
    u[i]=[];
    v[i]=[];
    w[i]=[];
    p[i]=[];
    t[i]=[];
    for(var j=0;j<model.grid.ny;j++){
      u[i][j]=[];
      v[i][j]=[];
      w[i][j]=[];
      p[i][j]=[];
      t[i][j]=[];
      for(var k=0;k<model.grid.nz;k++){
      	u[i][j][k]=0;
      	v[i][j][k]=0;
      	w[i][j][k]=0;
      	p[i][j][k]=0;
      	t[i][j][k]=0;
      }
      t[i][j][0]=tHeat;
    }
  }
  model.setInitField(u,v,w,p,t);
  model.gravity.set(0,0,-grav);
}

//--------------------------------------------------------------------//
// \f
// canvasId - \̈ID
var ViewModel=function(canvasId){
  this.canvasFrame=document.getElementById(canvasId);		// `t[
  this.renderer=new THREE.WebGLRenderer({antialias:true});	// _\
  if(!this.renderer){
    alert("three.js ̏Ɏs܂");
  }

  this.renderer.setSize(this.canvasFrame.clientWidth,
      	      	      	this.canvasFrame.clientHeight);
  this.canvasFrame.appendChild(this.renderer.domElement);

  this.renderer.setClearColor(0x000000,1);
  this.scene=new THREE.Scene();					// V[
  this.initLight();
  this.initCamera();
  this.axis=null;
};

// 
ViewModel.prototype.initLight=function(){
// s
  this.directionalLight=new THREE.DirectionalLight(0xffffff,1.0);
  bounds.setLightPosition(this.directionalLight.position);
  this.scene.add(this.directionalLight);
// 
  this.ambientLight=new THREE.AmbientLight(0xcccccc);
  this.scene.add(this.ambientLight);
};

// J
ViewModel.prototype.initCamera=function(){
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size,c=bounds.center;
// J
  this.camera=new THREE.OrthographicCamera
    (-side*aspect,side*aspect,side,-side,
     0.01*bounds.size,100*bounds.size);
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
//  this.camera.lookAt({x:0,y:0,z:0});	Controlsgp͖

// gbN{[Rg[
  this.trackball=new THREE.OrthographicTrackballControls
      	      	   (this.camera,this.canvasFrame);
  this.trackball.screen.width=this.canvasFrame.clientWidth;
  this.trackball.screen.height=this.canvasFrame.clientHeight;
  var bdc=this.canvasFrame.getBoundingClientRect();
  this.trackball.screen.offetLeft=bdc.left;
  this.trackball.screen.offetTop=bdc.top;

  this.trackball.noRotate=false;
  this.trackball.rotateSpeed=4.0;
  this.trackball.noZoom=false;
  this.trackball.zoomSpeed=4.0;
  this.trackball.noPan=false;
  this.trackball.panSpeed=1.0;
  this.trackball.target.copy(c);
  this.trackball.staticMoving=true;
  this.trackball.dynamicDampingFactor=0.3;
};

// \IuWFNgǉ
ViewModel.prototype.addObject=function(obj){
  this.scene.add(obj);
};

// \IuWFNg폜
ViewModel.prototype.removeObject=function(obj){
  this.scene.remove(obj);
};

// Wݒ肷
ViewModel.prototype.setAxis=function(){
  if(this.axis!==null){
    this.scene.remove(this.axis);
  }
  this.axis=new THREE.AxisHelper(0.2*bounds.size);
  this.axis.position.set(0,0,0);
  this.scene.add(this.axis);
};

// EJʒuXV
ViewModel.prototype.updateLightAndCamera=function(){
  bounds.setLightPosition(this.directionalLight.position);
  var aspect=this.canvasFrame.clientWidth/this.canvasFrame.clientHeight;
  var side=0.7*bounds.size;
  this.camera.left=-side*aspect;
  this.camera.right=side*aspect;
  this.camera.top=side;
  this.camera.bottom=-side;
  this.camera.near=0.01*bounds.size;
  this.camera.far=100*bounds.size;
  this.viewZ();
};

// \XV
ViewModel.prototype.update=function(){
  this.trackball.update();
  this.renderer.render(this.scene,this.camera);
};

// _Xɂ
ViewModel.prototype.viewX=function(){
  var c=bounds.center;
  this.camera.position.set(c.x+bounds.viewPoint,c.y,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Yɂ
ViewModel.prototype.viewY=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y-bounds.viewPoint,c.z);
  this.camera.up.set(0,0,1);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

// _Zɂ
ViewModel.prototype.viewZ=function(){
  var c=bounds.center;
  this.camera.position.set(c.x,c.y,c.z+bounds.viewPoint);
  this.camera.up.set(0,1,0);
  this.camera.zoom=1;
  this.camera.updateProjectionMatrix();
  this.trackball.target.copy(c);
};

//--------------------------------------------------------------------//
// fE
var Bounds=function(x1,x2,y1,y2,z1,z2){
  this.box=new THREE.Box3(new THREE.Vector3(x1,y1,z1),
      	      	      	  new THREE.Vector3(x2,y2,z2));
  this.center=this.box.getCenter().clone();
  this.size=Math.max(x2-x1,y2-y1,z2-z1);
  this.viewPoint=2*this.size;
};

// ʒuݒ肷
// p - ʒu
Bounds.prototype.setLightPosition=function(p){
  p.set(this.size,-this.size,this.size);
};

//--------------------------------------------------------------------//
// \iqf[^f
var GridModel=function(){
  this.nx=0;				// xiq_
  this.ny=0;				// yiq_
  this.nz=0;				// ziq_
  this.grid=[];				// iq_
  this.trans=[];			// iq_̕ϊs
  this.transU=[];			// xx̕ϊs
  this.transV=[];			// xy̕ϊs
  this.transW=[];			// xz̕ϊs
  this.transP=[];			// ͓_̕ϊs
  this.diffU=[];			// xx̊gǓW
  this.diffV=[];			// xẙgǓW
  this.diffW=[];			// xz̊gǓW
  this.diffP=[];			// ͓_̊gǓW
};

// p[^ݒ肷
// nx,ny,nz - x,y,ziq_
// grid - iq_̃Xg
// bc - E
GridModel.prototype.setGrid=function(nx,ny,nz,grid,bc){
  this.nx=nx;
  this.ny=ny;
  this.nz=nz;
  this.grid=grid;
  this.metric(bc);
};

// xvZ
// bc - E
GridModel.prototype.metric=function(bc){
  this.trans.length=0;
  this.transU.length=0;
  this.transV.length=0;
  this.transW.length=0;
  this.transP.length=0;
  this.diffU.length=0;
  this.diffV.length=0;
  this.diffW.length=0;
  this.diffP.length=0;
  var i,j,k;
  for(i=0;i<this.nx+2;i++){
    this.trans[i]=[];
    for(j=0;j<this.ny+2;j++){
      this.trans[i][j]=[];
    }
  }
  this.metricAtGrid(bc);
  for(i=0;i<this.nx+2;i++){
    this.transU[i]=[];
    this.diffU[i]=[];
    for(j=0;j<this.ny+1;j++){
      this.transU[i][j]=[];
      this.diffU[i][j]=[];
      for(k=0;k<this.nz+1;k++){
      	this.transU[i][j][k]=createTransform4
      	  (this.trans[i][j][k],this.trans[i][j+1][k],
      	   this.trans[i][j][k+1],this.trans[i][j+1][k+1]);
      	this.diffU[i][j][k]=new DiffusionCoef();
      }
    }
  }
  for(i=0;i<this.nx+1;i++){
    this.transV[i]=[];
    this.diffV[i]=[];
    for(j=0;j<this.ny+2;j++){
      this.transV[i][j]=[];
      this.diffV[i][j]=[];
      for(k=0;k<this.nz+1;k++){
      	this.transV[i][j][k]=createTransform4
      	  (this.trans[i][j][k],this.trans[i+1][j][k],
      	   this.trans[i][j][k+1],this.trans[i+1][j][k+1]);
      	this.diffV[i][j][k]=new DiffusionCoef();
      }
    }
    this.transW[i]=[];
    this.diffW[i]=[];
    this.transP[i]=[];
    this.diffP[i]=[];
    for(j=0;j<this.ny+1;j++){
      this.transW[i][j]=[];
      this.diffW[i][j]=[];
      for(k=0;k<this.nz+2;k++){
      	this.transW[i][j][k]=createTransform4
      	  (this.trans[i][j][k],this.trans[i+1][j][k],
      	   this.trans[i][j+1][k],this.trans[i+1][j+1][k]);
      	this.diffW[i][j][k]=new DiffusionCoef();
      }
      this.transP[i][j]=[];
      this.diffP[i][j]=[];
      for(k=0;k<this.nz+1;k++){
      	this.transP[i][j][k]=createTransform2
      	  (this.transW[i][j][k],this.transW[i][j][k+1]);
      	this.diffP[i][j][k]=new DiffusionCoef();
      }
    }
  }
  this.setDiffusionCoef();
};

// iq_̑xvZ
// bc - E
GridModel.prototype.metricAtGrid=function(bc){
  var j,k,kk,min=Math.min,max=Math.max;
  for(var i=1;i<=this.nx;i++){
    for(j=1;j<=this.ny;j++){
      for(k=1;k<=this.nz;k++){
      	this.trans[i][j][k]=this.createTransform(i-1,j-1,k-1);
      }
      if(bc[i-1][j-1][0]===PERIODIC){
      	this.trans[i][j][0]=this.trans[i][j][this.nz-1];
      }
      else{
      	this.trans[i][j][0]=this.trans[i][j][1];
      }
      if(bc[i-1][j-1][this.nz-1]===PERIODIC){
      	this.trans[i][j][this.nz+1]=this.trans[i][j][2];
      }
      else{
      	this.trans[i][j][this.nz+1]=this.trans[i][j][this.nz];
      }
    }
    for(k=0;k<this.nz+2;k++){
      kk=min(max(k-1,0),this.nz-1);
      if(bc[i-1][0][kk]===PERIODIC){
      	this.trans[i][0][k]=this.trans[i][this.ny-1][k];
      }
      else{
      	this.trans[i][0][k]=this.trans[i][1][k];
      }
      if(bc[i-1][this.ny-1][kk]===PERIODIC){
      	this.trans[i][this.ny+1][k]=this.trans[i][2][k];
      }
      else{
      	this.trans[i][this.ny+1][k]=this.trans[i][this.ny][k];
      }
    }
  }
  for(j=0;j<this.ny+2;j++){
    var jj=min(max(j-1,0),this.ny-1);
    for(k=0;k<this.nz+2;k++){
      kk=min(max(k-1,0),this.nz-1);
      if(bc[0][jj][kk]===PERIODIC){
      	this.trans[0][j][k]=this.trans[this.nx-1][j][k];
      }
      else{
      	this.trans[0][j][k]=this.trans[1][j][k];
      }
      if(bc[this.nx-1][jj][kk]===PERIODIC){
      	this.trans[this.nx+1][j][k]=this.trans[2][j][k];
      }
      else{
      	this.trans[this.nx+1][j][k]=this.trans[this.nx][j][k];
      }
    }
  }
};

// iq_̕ϊsvZĕԂ
// i,j,k - x,y,zCfbNX
GridModel.prototype.createTransform=function(i,j,k){
  var tr=[[],[],[]],gr,gr1,gr2,gr3;
  if(i===0){
    gr1=this.grid[0][j][k];
    gr2=this.grid[1][j][k];
    gr3=this.grid[2][j][k];
    tr[0]=[0.5*(-3*gr1.x+4*gr2.x-gr3.x),0.5*(-3*gr1.y+4*gr2.y-gr3.y),
      	   0.5*(-3*gr1.z+4*gr2.z-gr3.z)];
  }
  else if(i===this.nx-1){
    gr1=this.grid[this.nx-3][j][k];
    gr2=this.grid[this.nx-2][j][k];
    gr3=this.grid[this.nx-1][j][k];
    tr[0]=[0.5*(gr1.x-4*gr2.x+3*gr3.x),0.5*(gr1.y-4*gr2.y+3*gr3.y),
      	   0.5*(gr1.z-4*gr2.z+3*gr3.z)];
  }
  else{
    gr1=this.grid[i+1][j][k];
    gr2=this.grid[i-1][j][k];
    tr[0]=[0.5*(gr1.x-gr2.x),0.5*(gr1.y-gr2.y),0.5*(gr1.z-gr2.z)];
  }
  gr=this.grid[i];
  if(j===0){
    gr1=gr[0][k];
    gr2=gr[1][k];
    gr3=gr[2][k];
    tr[1]=[0.5*(-3*gr1.x+4*gr2.x-gr3.x),0.5*(-3*gr1.y+4*gr2.y-gr3.y),
      	   0.5*(-3*gr1.z+4*gr2.z-gr3.z)];
  }
  else if(j===this.ny-1){
    gr1=gr[this.ny-3][k];
    gr2=gr[this.ny-2][k];
    gr3=gr[this.ny-1][k];
    tr[1]=[0.5*(gr1.x-4*gr2.x+3*gr3.x),0.5*(gr1.y-4*gr2.y+3*gr3.y),
      	   0.5*(gr1.z-4*gr2.z+3*gr3.z)];
  }
  else{
    gr1=gr[j+1][k];
    gr2=gr[j-1][k];
    tr[1]=[0.5*(gr1.x-gr2.x),0.5*(gr1.y-gr2.y),0.5*(gr1.z-gr2.z)];
  }
  gr=this.grid[i][j];
  if(k===0){
    gr1=gr[0];
    gr2=gr[1];
    gr3=gr[2];
    tr[2]=[0.5*(-3*gr1.x+4*gr2.x-gr3.x),0.5*(-3*gr1.y+4*gr2.y-gr3.y),
      	   0.5*(-3*gr1.z+4*gr2.z-gr3.z)];
  }
  else if(k===this.nz-1){
    gr1=gr[this.nz-3];
    gr2=gr[this.nz-2];
    gr3=gr[this.nz-1];
    tr[2]=[0.5*(gr1.x-4*gr2.x+3*gr3.x),0.5*(gr1.y-4*gr2.y+3*gr3.y),
      	   0.5*(gr1.z-4*gr2.z+3*gr3.z)];
  }
  else{
    gr1=gr[k+1];
    gr2=gr[k-1];
    tr[2]=[0.5*(gr1.x-gr2.x),0.5*(gr1.y-gr2.y),0.5*(gr1.z-gr2.z)];
  }
  return new Transform(tr);
};

// gǓWݒ肷
GridModel.prototype.setDiffusionCoef=function(){
  var i,j,k,tr1,tr2,tp1,tp2,dij;
  for(i=1;i<=this.nx;i++){
    for(j=1;j<this.ny;j++){
      tr1=this.trans[i][j];
      tr2=this.trans[i][j+1];
      tp1=this.transP[i][j];
      tp2=this.transP[i-1][j];
      dij=this.diffU[i][j];
      for(k=1;k<this.nz;k++){
      	dij[k].d=diffCoef(tp1[k],tp2[k],
      	      	      	  createTransform2(tr2[k],tr2[k+1]),
      	      	      	  createTransform2(tr1[k],tr1[k+1]),
      	      	      	  createTransform2(tr1[k+1],tr2[k+1]),
      	      	      	  createTransform2(tr1[k],tr2[k]));
      }
    }
  }
  for(i=1;i<this.nx;i++){
    for(j=1;j<=this.ny;j++){
      tr1=this.trans[i][j];
      tr2=this.trans[i+1][j];
      tp1=this.transP[i][j];
      tp2=this.transP[i][j-1];
      dij=this.diffV[i][j];
      for(k=1;k<this.nz;k++){
      	dij[k].d=diffCoef(createTransform2(tr2[k],tr2[k+1]),
      	      	      	  createTransform2(tr1[k],tr1[k+1]),
      	      	      	  tp1[k],tp2[k],
      	      	      	  createTransform2(tr1[k+1],tr2[k+1]),
      	      	      	  createTransform2(tr1[k],tr2[k]));
      }
    }
    for(j=1;j<this.ny;j++){
      tr1=this.trans[i][j];
      tr2=this.trans[i+1][j];
      var tr3=this.trans[i][j+1],tr4=this.trans[i+1][j+1];
      tp1=this.transP[i][j];
      dij=this.diffW[i][j];
      for(k=1;k<=this.nz;k++){
      	dij[k].d=diffCoef(createTransform2(tr2[k],tr4[k]),
      	      	      	  createTransform2(tr1[k],tr3[k]),
      	      	      	  createTransform2(tr3[k],tr4[k]),
      	      	      	  createTransform2(tr1[k],tr2[k]),
      	      	      	  tp1[k],tp1[k-1]);
      }
    }
  }
  for(i=1;i<this.nx;i++){
    for(j=1;j<this.ny;j++){
      var tu1=this.transU[i+1][j],tu2=this.transU[i][j];
      var tv1=this.transV[i][j+1],tv2=this.transV[i][j];
      var tw=this.transW[i][j];
      dij=this.diffP[i][j];
      for(k=1;k<this.nz;k++){
      	dij[k].d=diffCoef(tu1[k],tu2[k],tv1[k],tv2[k],tw[k+1],tw[k]);
      }
    }
  } 
};

// gUWvZXgԂ
// txp,txm - x+Ex-̍Wϊs
// typ,tym - y+Ey-̍Wϊs
// tzp,tzm - z+Ez-̍Wϊs
function diffCoef(txp,txm,typ,tym,tzp,tzm){
  return [[[0,0.25*(txm.c12()+tym.c12()),0],
      	   [0.25*(txm.c31()+tzm.c31()),txm.c11(),
      	    -0.25*(txm.c31()+tzp.c31())],
      	   [0,-0.25*(txp.c12()+tym.c12()),0]],
      	  [[0.25*(tym.c23()+tzm.c23()),tym.c22(),
      	    -0.25*(tym.c23()+tzp.c23())],
      	   [tzm.c33(),
      	    txp.c11()+txm.c11()+typ.c22()+tym.c22()+tzp.c33()+tzm.c33(),
      	    tzp.c33()],
      	   [-0.25*(typ.c23()+tzm.c23()),typ.c22(),
      	    0.25*(typ.c23()+tzp.c23())]],
      	  [[0,-0.25*(txp.c12()+tym.c12()),0],
      	   [-0.25*(txp.c31()+tzm.c31()),txp.c11(),
      	    0.25*(txp.c31()+tzp.c31())],
      	   [0,0.25*(txp.c12()+typ.c12()),0]]];
}

//--------------------------------------------------------------------//
// \iqL̐ϖ@f[^f
var FVMDataModel=function(){
  this.grid=new GridModel();		// \iqf[^f
  this.param=new FlowParameter(0,0);	// ̃p[^
  this.flowBc=[];			// ꋫE
  this.heatBc=[];			// ME
  this.u=[];				// xx
  this.v=[];				// xy
  this.w=[];				// xz
  this.p=[];				// 
  this.p0=[];				// 
  this.t=[];				// x
  this.t0=[];				// x
  this.uu=[];				// ϑx̐
  this.vv=[];				// ϑxŐ
  this.ww=[];				// ϑxĐ
  this.dp=[];				// ͕␳
  this.du=[];				// ϑx͕̐̈␳W
  this.dv=[];				// ϑxŐ͕̈␳W
  this.dw=[];				// ϑxĐ͕̈␳W
  this.coef=[];				// šW
  this.section=new Pointer();		// ͕␳
  this.gravity=new THREE.Vector3();	// d͉xxNg
  this.uCondition=new SORCondition(2,0.4,1e-8);		// xx̌vZ
  this.vCondition=new SORCondition(2,0.4,1e-8);		// xy̌vZ
  this.wCondition=new SORCondition(2,0.4,1e-8);		// xžvZ
  this.pCondition=new SORCondition(10,0.7,1e-8);	// ͂̌vZ
  this.tCondition=new SORCondition(3,0.6,1e-8);		// x̌vZ
};

// Eݒ肷
// flowBc - ꋫE
// heatBc - ME
FVMDataModel.prototype.setBC=function(flowBc,heatBc){
  this.flowBc=flowBc;
  this.heatBc=heatBc;
};

// iq_f[^ݒ肷
FVMDataModel.prototype.setGridData=function(){
  this.u.length=0;
  this.v.length=0;
  this.w.length=0;
  this.uu.length=0;
  this.vv.length=0;
  this.ww.length=0;
  this.p.length=0;
  this.t.length=0;
  this.dp.length=0;
  this.du.length=0;
  this.dv.length=0;
  this.dw.length=0;
  this.coef.length=0;
  var i,j,k,nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(i=0;i<nx+2;i++){
    this.u[i]=[];
    this.uu[i]=[];
    for(j=0;j<=ny;j++){
      this.u[i][j]=[];
      this.uu[i][j]=[];
      for(k=0;k<=nz;k++){
      	this.u[i][j][k]=0;
      	this.uu[i][j][k]=0;
      }
    }
  }
  for(i=0;i<=nx;i++){
    this.v[i]=[];
    this.vv[i]=[];
    this.w[i]=[];
    this.ww[i]=[];
    this.p[i]=[];
    this.t[i]=[];
    this.dp[i]=[];
    this.du[i]=[];
    this.dv[i]=[];
    this.dw[i]=[];
    this.coef[i]=[];
    for(j=0;j<ny+2;j++){
      this.v[i][j]=[];
      this.vv[i][j]=[];
      for(k=0;k<=nz;k++){
      	this.v[i][j][k]=0;
      	this.vv[i][j][k]=0;
      }
    }
    for(j=0;j<=ny;j++){
      this.w[i][j]=[];
      this.ww[i][j]=[];
      this.p[i][j]=[];
      this.t[i][j]=[];
      this.dp[i][j]=[];
      this.du[i][j]=[];
      this.dv[i][j]=[];
      this.dw[i][j]=[];
      this.coef[i][j]=[];
      for(k=0;k<=nz;k++){
      	this.w[i][j][k]=0;
      	this.ww[i][j][k]=0;
      	this.p[i][j][k]=0;
      	this.t[i][j][k]=0;
      	this.dp[i][j][k]=0;
      	this.du[i][j][k]=0;
      	this.dv[i][j][k]=0;
      	this.dw[i][j][k]=0;
      	this.coef[i][j][k]=new MatrixCoef();
      }
      this.w[i][j][nz+1]=0;
      this.ww[i][j][nz+1]=0;
    }
  }
  this.section.set(-1,-1,parseInt(nz/2));
};

// fʂ̊iq_Ԃ
// bc - E
FVMDataModel.prototype.getSectionGrid=function(){
  var pg=[],pg1,i,j,k,gr=this.grid.grid,gr1;
  var nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  if(this.section.x>=0){
    var x=this.section.x;
    for(j=0;j<ny;j++){
      pg1=[];
      gr1=gr[x][j];
      for(k=0;k<nz;k++){
      	pg1[k]=gr1[k];
      }
      pg[j]=pg1;
    }
  }
  if(this.section.y>=0){
    var y=this.section.y;
    for(i=0;i<nx;i++){
      pg1=[];
      gr1=gr[i][y];
      for(k=0;k<nz;k++){
      	pg1[k]=gr1[k];
      }
      pg[i]=pg1;
    }
  }
  if(this.section.z>=0){
    var z=this.section.z;
    for(i=0;i<nx;i++){
      pg1=[];
      gr1=gr[i];
      for(j=0;j<ny;j++){
      	pg1[j]=gr1[j][z];
      }
      pg[i]=pg1;
    }
  }
  return pg;
};

// fʂݒ肷
// sect - f 1:X-Y,2:Y-Z,3:Z-X
FVMDataModel.prototype.setSection=function(sect){
  switch(sect){
    case 0:
      this.section.set(-1,-1,parseInt(this.grid.nz/2));
      break;
    case 1:
      this.section.set(parseInt(this.grid.nx/2),-1,-1);
      break;
    case 2:
      this.section.set(-1,parseInt(this.grid.ny/2),-1);
      break;
  }
};

// ϑxvZ
FVMDataModel.prototype.contraVarVel=function(){
  var i,j,k,u0,u1,u2,v0,v1,v2,w0,w1,w2,tr;
  var nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(i=1;i<=nx;i++){
    v1=this.v[i-1];
    v2=this.v[i];
    w1=this.w[i-1];
    w2=this.w[i];
    for(j=1;j<ny;j++){
      tr=this.grid.transU[i][j];
      u1=this.u[i][j];
      for(k=1;k<nz;k++){
      	v0=0.25*(v1[j][k]+v1[j+1][k]+v2[j][k]+v2[j+1][k]);
      	w0=0.25*(w1[j][k]+w1[j][k+1]+w2[j][k]+w2[j][k+1]);
      	this.uu[i][j][k]=tr[k].contraVx(u1[k],v0,w0);
      }
    }
  }
  for(i=1;i<nx;i++){
    u1=this.u[i];
    u2=this.u[i+1];
    for(j=1;j<=ny;j++){
      v1=this.v[i][j];
      w1=this.w[i][j-1];
      w2=this.w[i][j];
      tr=this.grid.transV[i][j];
      for(k=1;k<nz;k++){
      	u0=0.25*(u1[j-1][k]+u2[j-1][k]+u1[j][k]+u2[j][k]);
      	w0=0.25*(w1[k]+w1[k+1]+w2[k]+w2[k+1]);
      	this.vv[i][j][k]=tr[k].contraVy(u0,v1[k],w0);
      }
    }
    for(j=1;j<ny;j++){
      u1=this.u[i][j];
      u2=this.u[i+1][j];
      v1=this.v[i][j];
      v2=this.v[i][j+1];
      w1=this.w[i][j];
      tr=this.grid.transW[i][j];
      for(k=1;k<=nz;k++){
      	u0=0.25*(u1[k-1]+u2[k-1]+u1[k]+u2[k]);
      	v0=0.25*(v1[k-1]+v2[k-1]+v1[k]+v2[k]);
      	this.ww[i][j][k]=tr[k].contraVz(u0,v0,w1[k]);
      }
    }
  }
};

// p[^zݒ肷
// ug,vg,wg,pg,tg - iq_̑xx,y,z,,x
FVMDataModel.prototype.setInitField=function(ug,vg,wg,pg,tg){
  var i,j,k,nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  this.p0=pg;
  this.t0=tg;
  for(i=1;i<=nx;i++){
    for(j=1;j<ny;j++){
      var ug1=ug[i-1][j-1],ug2=ug[i-1][j];
      for(k=1;k<nz;k++){
      	this.u[i][j][k]=0.25*(ug1[k-1]+ug2[k-1]+ug1[k]+ug2[k]);
      }
    }
  }
  for(i=1;i<nx;i++){
    for(j=1;j<=ny;j++){
      var vg1=vg[i-1][j-1],vg2=vg[i][j-1];
      for(k=1;k<nz;k++){
      	this.v[i][j][k]=0.25*(vg1[k-1]+vg1[k]+vg2[k-1]+vg2[k]);
      }
    }
    var wg1=wg[i-1],wg2=wg[i];
    for(j=1;j<ny;j++){
      for(k=1;k<=nz;k++){
      	this.w[i][j][k]=0.25*(wg1[j-1][k-1]+wg2[j-1][k-1]+
      	      	      	      wg1[j][k-1]+wg2[j][k-1]);
      }
    }
  }
  for(i=1;i<nx;i++){
    var pg1=pg[i],pg2=pg[i-1],tg1=tg[i],tg2=tg[i-1];
    for(j=1;j<ny;j++){
      for(k=1;k<nz;k++){
      	this.p[i][j][k]=0.125*(pg1[j][k]+pg2[j][k]+pg1[j-1][k]+
      	      	      	       pg2[j-1][k]+pg1[j][k-1]+pg2[j][k-1]+
      	      	      	       pg1[j-1][k-1]+pg2[j-1][k-1]);
      	this.t[i][j][k]=0.125*(tg1[j][k]+tg2[j][k]+tg1[j-1][k]+
      	      	      	       tg2[j-1][k]+tg1[j][k-1]+tg2[j][k-1]+
      	      	      	       tg1[j-1][k-1]+tg2[j-1][k-1]);
      }
    }
  }
  this.setBCforU(this.flowBc);
  this.setBCforV(this.flowBc);
  this.setBCforW(this.flowBc);
  this.setBCforC(this.flowBc,this.p,this.p0);
  this.setBCforC(this.heatBc,this.t,this.t0);
};

// xxʒu̔ϑxԂ
// i,j,k - x,y,zCfbNX
FVMDataModel.prototype.contraAtU=function(i,j,k){
  var trans=this.grid.transU[i][j][k];
  var vv1=this.v[i-1],vv2=this.v[i];
  var ww1=this.w[i-1][j],ww2=this.w[i][j];
  var up=this.u[i][j][k];
  var vp=0.25*(vv1[j][k]+vv1[j+1][k]+vv2[j][k]+vv2[j+1][k]);
  var wp=0.25*(ww1[k]+ww1[k+1]+ww2[k]+ww2[k+1]);
  return new THREE.Vector3(trans.contraVx(up,vp,wp),
      	      	      	   trans.contraVy(up,vp,wp),
      	      	      	   trans.contraVz(up,vp,wp));
};

// xyʒu̔ϑxԂ
// i,j,k - x,y,zCfbNX
FVMDataModel.prototype.contraAtV=function(i,j,k){
  var trans=this.grid.transV[i][j][k];
  var uu1=this.u[i],uu2=this.u[i+1],ww=this.w[i];
  var up=0.25*(uu1[j-1][k]+uu2[j-1][k]+uu1[j][k]+uu2[j][k]);
  var vp=this.v[i][j][k];
  var wp=0.25*(ww[j-1][k]+ww[j-1][k+1]+ww[j][k]+ww[j][k+1]);
  return new THREE.Vector3(trans.contraVx(up,vp,wp),
      	      	      	   trans.contraVy(up,vp,wp),
      	      	      	   trans.contraVz(up,vp,wp));
};

// xzʒu̔ϑxԂ
// i,j,k - x,y,zCfbNX
FVMDataModel.prototype.contraAtW=function(i,j,k){
  var trans=this.grid.transW[i][j][k];
  var uu1=this.u[i][j],uu2=this.u[i+1][j],vv=this.v[i];
  var up=0.25*(uu1[k-1]+uu2[k-1]+uu1[k]+uu2[k]);
  var vp=0.25*(vv[j][k-1]+vv[j+1][k-1]+vv[j][k]+vv[j+1][k]);
  var wp=this.w[i][j][k];
  return new THREE.Vector3(trans.contraVx(up,vp,wp),
      	      	      	   trans.contraVy(up,vp,wp),
      	      	      	   trans.contraVz(up,vp,wp));
};

// xx̋Eݒ肷
// bc - E
FVMDataModel.prototype.setBCforU=function(bc){
  var i,j,k,up,uu,nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(j=1;j<this.grid.ny;j++){
    for(k=1;k<nz;k++){
      if(bcYZ(bc,0,j,k,WALL)){
      	this.u[1][j][k]=0;
      	this.u[0][j][k]=-this.u[2][j][k];
      }
      else if(bcYZ(bc,0,j,k,PERIODIC)){
      	this.u[1][j][k]=this.u[nx][j][k];
      	this.u[0][j][k]=this.u[nx-1][j][k];
      }
      else if(bcYZ(bc,0,j,k,SLIP)){
      	up=this.contraAtU(2,j,k);
      	this.u[0][j][k]=this.grid.transU[2][j][k].vx(-up.x,up.y,up.z);
      }
      if(bcYZ(bc,nx-1,j,k,WALL)){
      	this.u[nx][j][k]=0;
      	this.u[nx+1][j][k]=-this.u[nx-1][j][k];
      }
      else if(bcYZ(bc,nx-1,j,k,PERIODIC)){
      	this.u[nx][j][k]=this.u[1][j][k];
      	this.u[nx+1][j][k]=this.u[2][j][k];
      }
      else if(bcYZ(bc,nx-1,j,k,SLIP)){
      	up=this.contraAtU(nx-1,j,k);
      	this.u[nx+1][j][k]=
      	  this.grid.transU[nx-1][j][k].vx(-up.x,up.y,up.z);
      }
    }
  }
  for(i=1;i<=nx;i++){
    for(j=1;j<ny;j++){
      uu=this.u[i][j];
      if(bcY(bc,i-1,j,0,WALL)){
      	uu[0]=-uu[1];
      }
      else if(bcY(bc,i-1,j,0,PERIODIC)){
      	uu[0]=uu[nz-1];
      }
      else if(bcY(bc,i-1,j,0,SLIP)){
      	up=this.contraAtU(i,j,1);
      	uu[0]=this.grid.transU[i][j][1].vx(up.x,up.y,-up.z);
      }
      else{
      	uu[0]=uu[1];
      }
      if(bcY(bc,i-1,j,nz-1,WALL)){
      	uu[nz]=-uu[nz-1];
      }
      else if(bcY(bc,i-1,j,nz-1,PERIODIC)){
      	uu[nz]=uu[1];
      }
      else if(bcY(bc,i-1,j,nz-1,SLIP)){
      	up=this.contraAtU(i,j,nz-1);
      	uu[nz]=this.grid.transU[i][j][nz-1].vx(up.x,up.y,-up.z);
      }
      else{
      	uu[nz]=uu[nz-1];
      }
    }
  }
  for(i=1;i<=nx;i++){
    uu=this.u[i];
    for(k=1;k<nz;k++){
      if(bcZ(bc,i-1,0,k,WALL)){
      	uu[0][k]=-uu[1][k];
      }
      else if(bcZ(bc,i-1,0,k,PERIODIC)){
      	uu[0][k]=uu[ny-1][k];
      }
      else if(bcZ(bc,i-1,0,k,SLIP)){
      	up=this.contraAtU(i,1,k);
      	uu[0][k]=this.grid.transU[i][1][k].vx(up.x,-up.y,up.z);
      }
      else{
      	uu[0][k]=uu[1][k];
      }
      if(bcZ(bc,i-1,ny-1,k,WALL)){
      	uu[ny][k]=-uu[ny-1][k];
      }
      else if(bcZ(bc,i-1,ny-1,k,PERIODIC)){
      	uu[ny][k]=uu[1][k];
      }
      else if(bcZ(bc,i-1,ny-1,k,SLIP)){
      	up=this.contraAtU(i,ny-1,k);
      	uu[ny][k]=
      	  this.grid.transU[i][ny-1][k].vx(up.x,-up.y,up.z);
      }
      else{
      	uu[ny][k]=uu[ny-1][k];
      }
    }
  }
};

// xy̋Eݒ肷
// bc - E
FVMDataModel.prototype.setBCforV=function(bc){
  var i,j,k,vp,vv,nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(i=1;i<nx;i++){
    vv=this.v[i];
    for(k=1;k<nz;k++){
      if(bcZX(bc,i,0,k,WALL)){
      	vv[1][k]=0;
      	vv[0][k]=-vv[2][k];
      }
      else if(bcZX(bc,i,0,k,PERIODIC)){
      	vv[1][k]=vv[ny][k];
      	vv[0][k]=vv[ny-1][k];
      }
      else if(bcZX(bc,i,0,k,SLIP)){
      	vp=this.contraAtV(i,2,k);
      	vv[0][k]=this.grid.transV[i][2][k].vy(vp.x,-vp.y,vp.z);
      }
      if(bcZX(bc,i,ny-1,k,WALL)){
      	vv[ny][k]=0;
      	vv[ny+1][k]=-vv[ny-1][k];
      }
      else if(bcZX(bc,i,ny-1,k,PERIODIC)){
      	vv[ny][k]=vv[1][k];
      	vv[ny+1][k]=vv[2][k];
      }
      else if(bcZX(bc,i,ny-1,k,SLIP)){
      	vp=this.contraAtV(i,ny-1,k);
      	vv[ny+1][k]=
      	  this.grid.transV[i][ny-1][k].vy(vp.x,-vp.y,vp.z);
      }
    }
  }
  for(i=1;i<nx;i++){
    for(j=1;j<=ny;j++){
      vv=this.v[i][j];
      if(bcX(bc,i,j-1,0,WALL)){
      	vv[0]=-vv[1];
      }
      else if(bcX(bc,i,j-1,0,PERIODIC)){
      	vv[0]=vv[nz-1];
      }
      else if(bcX(bc,i,j-1,0,SLIP)){
      	vp=this.contraAtV(i,j,1);
      	vv[0]=this.grid.transV[i][j][1].vy(vp.x,vp.y,-vp.z);
      }
      else{
      	vv[0]=vv[1];
      }
      if(bcX(bc,i,j-1,nz-1,WALL)){
      	vv[nz]=-vv[nz-1];
      }
      else if(bcX(bc,i,j-1,nz-1,PERIODIC)){
      	vv[nz]=vv[1];
      }
      else if(bcX(bc,i,j-1,nz-1,SLIP)){
      	vp=this.contraAtV(i,j,nz-1);
      	vv[nz]=this.grid.transV[i][j][nz-1].vy(vp.x,vp.y,-vp.z);
      }
      else{
      	vv[nz]=vv[nz-1];
      }
    }
  }
  for(j=1;j<=ny;j++){
    for(k=1;k<nz;k++){
      if(bcZ(bc,0,j-1,k,WALL)){
      	this.v[0][j][k]=-this.v[1][j][k];
      }
      else if(bcZ(bc,0,j-1,k,PERIODIC)){
      	this.v[0][j][k]=this.v[nx-1][j][k];
      }
      else if(bcZ(bc,0,j-1,k,SLIP)){
      	vp=this.contraAtV(1,j,k);
      	this.v[0][j][k]=this.grid.transV[1][j][k].vy(-vp.x,vp.y,vp.z);
      }
      else{
      	this.v[0][j][k]=this.v[1][j][k];
      }
      if(bcZ(bc,nx-1,j-1,k,WALL)){
      	this.v[nx][j][k]=-this.v[nx-1][j][k];
      }
      else if(bcZ(bc,nx-1,j-1,k,PERIODIC)){
      	this.v[nx][j][k]=this.v[1][j][k];
      }
      else if(bcZ(bc,nx-1,j-1,k,SLIP)){
      	vp=this.contraAtV(nx-1,j,k);
      	this.v[nx][j][k]=
      	  this.grid.transV[nx-1][j][k].vy(-vp.x,vp.y,vp.z);
      }
      else{
      	this.v[nx][j][k]=this.v[nx-1][j][k];
      }
    }
  }
};

// xz̋Eݒ肷
// bc - E
FVMDataModel.prototype.setBCforW=function(bc){
  var i,j,k,wp,ww,nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(i=1;i<nx;i++){
    for(j=1;j<ny;j++){
      ww=this.w[i][j];
      if(bcXY(bc,i,j,0,WALL)){
      	ww[1]=0;
      	ww[0]=-ww[2];
      }
      else if(bcXY(bc,i,j,0,PERIODIC)){
      	ww[1]=ww[nz];
      	ww[0]=ww[nz-1];
      }
      else if(bcXY(bc,i,j,0,SLIP)){
      	wp=this.contraAtW(i,j,2);
      	ww[0]=this.grid.transW[i][j][2].vz(wp.x,wp.y,-wp.z);
      }
      if(bcXY(bc,i,j,nz-1,WALL)){
      	ww[nz]=0;
      	ww[nz+1]=-ww[nz-1];
      }
      else if(bcXY(bc,i,j,nz-1,PERIODIC)){
      	ww[nz]=ww[1];
      	ww[nz+1]=ww[2];
      }
      else if(bcXY(bc,i,j,nz-1,SLIP)){
      	wp=this.contraAtW(i,j,nz-1);
      	ww[nz+1]=this.grid.transW[i][j][nz-1].vz(wp.x,wp.y,-wp.z);
      }
    }
  }
  for(i=1;i<nx;i++){
    ww=this.w[i];
    for(k=1;k<=nz;k++){
      if(bcX(bc,i,0,k-1,WALL)){
      	ww[0][k]=-ww[1][k];
      }
      else if(bcX(bc,i,0,k-1,PERIODIC)){
      	ww[0][k]=ww[ny-1][k];
      }
      else if(bcX(bc,i,0,k-1,SLIP)){
      	wp=this.contraAtW(i,1,k);
      	ww[0][k]=this.grid.transW[i][1][k].vz(wp.x,-wp.y,wp.z);
      }
      else{
      	ww[0][k]=ww[1][k];
      }
      if(bcX(bc,i,ny-1,k-1,WALL)){
      	ww[ny][k]=-ww[ny-1][k];
      }
      else if(bcX(bc,i,ny-1,k-1,PERIODIC)){
      	ww[ny][k]=ww[1][k];
      }
      else if(bcX(bc,i,ny-1,k-1,SLIP)){
      	wp=this.contraAtW(i,ny-1,k);
      	ww[ny][k]=
      	  this.grid.transW[i][ny-1][k].vz(wp.x,-wp.y,wp.z);
      }
      else{
      	ww[ny][k]=ww[ny-1][k];
      }
    }
  }
  for(j=1;j<ny;j++){
    for(k=1;k<=nz;k++){
      if(bcY(bc,0,j,k-1,WALL)){
      	this.w[0][j][k]=-this.w[1][j][k];
      }
      else if(bcY(bc,0,j,k-1,PERIODIC)){
      	this.w[0][j][k]=this.w[nx-1][j][k];
      }
      else if(bcY(bc,0,j,k-1,SLIP)){
      	wp=this.contraAtW(1,j,k);
      	this.w[0][j][k]=this.grid.transW[1][j][k].vz(-wp.x,wp.y,wp.z);
      }
      else{
      	this.w[0][j][k]=this.w[1][j][k];
      }
      if(bcY(bc,nx-1,j,k-1,WALL)){
      	this.w[nx][j][k]=-this.w[nx-1][j][k];
      }
      else if(bcY(bc,nx-1,j,k-1,PERIODIC)){
      	this.w[nx][j][k]=this.w[1][j][k];
      }
      else if(bcY(bc,nx-1,j,k-1,SLIP)){
      	wp=this.contraAtW(nx-1,j,k);
      	this.w[nx][j][k]=
      	  this.grid.transW[nx-1][j][k].vz(-wp.x,wp.y,wp.z);
      }
      else{
      	this.w[nx][j][k]=this.w[nx-1][j][k];
      }
    }
  }
};

// iqp[^̋Eݒ肷
// bc - E
// p - p[^z
// p0 - p[^̊iq_̏z
FVMDataModel.prototype.setBCforC=function(bc,p,p0){
  var i,j,pp,pp0,p0p,p0m;
  var nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(var k=0;k<=nz;k++){
    var kper=k,km=k-1,kp=k;
    if(k===0){
      kper=nz-1;
      km=0;
    }
    if(k===nz){
      kper=1;
      kp=nz-1;
    }
    for(j=0;j<=ny;j++){
      var jper=j,jm=j-1,jp=j;
      if(j===0){
      	jper=ny-1;
      	jm=0;
      }
      if(j===ny){
      	jper=1;
      	jp=ny-1;
      }
      if(bcYZ(bc,0,jp,kp,PERIODIC)){
      	p[0][j][k]=p[nx-1][jper][kper];
      }
      else if(bcYZ(bc,0,jp,kp,FIX)){
      	pp0=p0[0];
      	p[0][j][k]=0.5*(pp0[jm][km]+pp0[jp][km]+pp0[jm][kp]+
      	      	      	pp0[jp][kp])-p[1][j][k];
      }
      else{
      	p[0][j][k]=p[1][j][k];
      }
      if(bcYZ(bc,nx-1,jp,kp,PERIODIC)){
      	p[nx][j][k]=p[1][jper][kper];
      }
      else if(bcYZ(bc,nx-1,jp,kp,FIX)){
      	pp0=p0[nx-1];
      	p[nx][j][k]=0.5*(pp0[jm][km]+pp0[jp][km]+pp0[jm][kp]+
      	      	      	 pp0[jp][kp])-p[nx-1][j][k];
      }
      else{
      	p[nx][j][k]=p[nx-1][j][k];
      }
    }
    for(i=0;i<=nx;i++){
      var iper=i,im=i-1,ip=i;
      if(i===0){
      	iper=nx-1;
      	im=0;
      }
      if(i===nx){
      	iper=1;
      	ip=nx-1;
      }
      pp=p[i];
      if(bcZX(bc,ip,0,kp,PERIODIC)){
      	pp[0][k]=p[iper][ny-1][kper];
      }
      else if(bcZX(bc,ip,0,kp,FIX)){
      	p0m=p0[im][0];
      	p0p=p0[ip][0];
      	pp[0][k]=0.5*(p0m[km]+p0m[kp]+p0p[km]+p0p[kp])-pp[1][k];
      }
      else{
      	pp[0][k]=pp[1][k];
      }
      if(bcZX(bc,ip,ny-1,kp,PERIODIC)){
      	pp[ny][k]=p[iper][1][kper];
      }
      else if(bcZX(bc,ip,ny-1,kp,FIX)){
      	p0m=p0[im][ny-1];
      	p0p=p0[ip][ny-1];
      	pp[ny][k]=0.5*(p0m[km]+p0p[km]+p0m[kp]+p0p[kp])-pp[ny-1][k];
      }
      else{
      	pp[ny][k]=pp[ny-1][k];
      }
    }
  }
  for(i=1;i<nx;i++){
    pp0=p0[i-1];
    var p01=p0[i];
    for(j=1;j<ny;j++){
      pp=p[i][j];
      if(bcXY(bc,i,j,0,PERIODIC)){
      	pp[0]=pp[nz-1];
      }
      else if(bcXY(bc,i,j,0,FIX)){
      	pp[0]=0.5*(pp0[j-1][0]+p01[j-1][0]+pp0[j][0]+p01[j][0])-pp[1];
      }
      else{
      	pp[0]=pp[1];
      }
      if(bcXY(bc,i,j,nz-1,PERIODIC)){
      	pp[nz]=pp[1];
      }
      else if(bcXY(bc,i,j,nz-1,FIX)){
      	pp[nz]=0.5*(pp0[j-1][nz-1]+p01[j-1][nz-1]+pp0[j][nz-1]+
      	      	    p01[j][nz-1])-pp[nz-1];
      }
      else{
      	pp[nz]=pp[nz-1];
      }
    }
  }
};

// iq_̃p[^̃XgԂ
// p iqS_̃p[^z
FVMDataModel.prototype.atGridPoint=function(p){
  var pp=[];
  for(var i=0;i<this.grid.nx;i++){
    pp[i]=[];
    for(var j=0;j<this.grid.ny;j++){
      pp[i][j]=[];
      var p1=p[i][j],p2=p[i][j+1],p3=p[i+1][j],p4=p[i+1][j+1];
      for(var k=0;k<this.grid.nz;k++){
      	pp[i][j][k]=0.125*(p1[k]+p2[k]+p3[k]+p4[k]+
      	      	      	   p1[k+1]+p2[k+1]+p3[k+1]+p4[k+1]);
      }
    }
  }
  return pp;
};

// ̃Xebv̌vZ
FVMDataModel.prototype.nextStep=function(){
  var resU=this.calcU();
  var resV=this.calcV();
  var resW=this.calcW();
  var resP=this.calcP();
  this.updateVel();
  var resT=this.calcT();
  this.param.next();
  var residual=Math.max(resU,resV,resW,resP,resT);
//  console.log('Res:'+residual);
//  console.log('U:'+resU+' V:'+resV+' W:'+resW+' P:'+resP+' T:'+resT);
  return residual;
};

// xxvZcԂ
FVMDataModel.prototype.calcU=function(){
  this.contraVarVel();
  var dti=this.param.dti;
  var kvis=this.param.kvis;
  var dinv=1/this.param.density;
  var buoyant=-this.param.beta*this.gravity.x;
  for(var i=1;i<=this.grid.nx;i++){
    var vv1=this.vv[i-1],vv2=this.vv[i];
    var p1=this.p[i-1],p2=this.p[i];
    for(var j=1;j<this.grid.ny;j++){
      var uu1=this.uu[i][j],uup1=this.uu[i+1][j],uum1=this.uu[i-1][j];
      var ww1=this.ww[i-1][j],ww2=this.ww[i][j];
      for(var k=1;k<this.grid.nz;k++){
      	var cf=this.coef[i][j][k];
      	if(isCalc(this.flowBc,i-1,j-1,k-1) ||
      	   isCalc(this.flowBc,i-1,j,k-1) ||
      	   isCalc(this.flowBc,i-1,j,k) ||
      	   isCalc(this.flowBc,i-1,j-1,k)){
      	  var uxp=0.5*(uu1[k]+uup1[k]);
      	  var uxm=0.5*(uu1[k]+uum1[k]);
      	  var vyp=0.5*(vv1[j+1][k]+vv2[j+1][k]);
      	  var vym=0.5*(vv1[j][k]+vv2[j][k]);
      	  var wzp=0.5*(ww1[k+1]+ww2[k+1]);
      	  var wzm=0.5*(ww1[k]+ww2[k]);
      	  var dpx=p2[j][k]-p1[j][k];
      	  var dpy=0.25*(p1[j+1][k]-p1[j-1][k]+p2[j+1][k]-p2[j-1][k]);
      	  var dpz=0.25*(p1[j][k+1]-p1[j][k-1]+p2[j][k+1]-p2[j][k-1]);
      	  var trans=this.grid.transU[i][j][k];
      	  var s=-dinv*trans.dpdx(dpx,dpy,dpz)+
      	      	 kvis*this.grid.diffU[i][j][k].crossTerm(i,j,k,this.u)+
      	      	 buoyant*trans.jacob*this.t[i][j][k];
      	  cf.setAdDf(uxp,uxm,vyp,vym,wzp,wzm,kvis,s,
      	      	     this.grid.diffU[i][j][k]);
      	  cf.setDt(trans.jacob*dti,this.u[i][j][k]);
      	  this.du[i][j][k]=dinv*trans.dfuxsi/cf.ac;
      	  cf.setCenter();
      	}
      	else{
      	  cf.fix(this.u[i][j][k]);
      	  this.du[i][j][k]=0;
      	}
      }
    }
  }
  this.setBCforU(this.flowBc);
  return this.uCondition.sor
    (1,this.grid.nx+1,1,this.grid.ny,1,this.grid.nz,this.u,this.coef);
};

// xyvZcԂ
FVMDataModel.prototype.calcV=function(){
  this.contraVarVel();
  var dti=this.param.dti;
  var kvis=this.param.kvis;
  var dinv=1/this.param.density;
  var buoyant=-this.param.beta*this.gravity.y;
  for(var i=1;i<this.grid.nx;i++){
    var uu1=this.uu[i],uu2=this.uu[i+1];
    var p1=this.p[i-1],p2=this.p[i],p3=this.p[i+1];
    for(var j=1;j<=this.grid.ny;j++){
      var vv1=this.vv[i][j],vvp1=this.vv[i][j+1],vvm1=this.vv[i][j-1];
      var ww1=this.ww[i][j-1],ww2=this.ww[i][j];
      for(var k=1;k<this.grid.nz;k++){
      	var cf=this.coef[i][j][k];
      	if(isCalc(this.flowBc,i-1,j-1,k-1) ||
      	   isCalc(this.flowBc,i-1,j-1,k) ||
      	   isCalc(this.flowBc,i,j-1,k-1) ||
      	   isCalc(this.flowBc,i,j-1,k)){
      	  var uxp=0.5*(uu2[j-1][k]+uu2[j][k]);
      	  var uxm=0.5*(uu1[j-1][k]+uu1[j][k]);
      	  var vyp=0.5*(vv1[k]+vvp1[k]);
      	  var vym=0.5*(vv1[k]+vvm1[k]);
      	  var wzp=0.5*(ww1[k+1]+ww2[k+1]);
      	  var wzm=0.5*(ww1[k]+ww2[k]);
      	  var dpx=0.25*(p3[j-1][k]-p1[j-1][k]+p3[j][k]-p1[j][k]);
      	  var dpy=p2[j][k]-p2[j-1][k];
      	  var dpz=0.25*(p2[j-1][k+1]-p2[j-1][k-1]+
      	      	      	p2[j][k+1]-p2[j][k-1]);
      	  var trans=this.grid.transV[i][j][k];
      	  var s=-dinv*trans.dpdy(dpx,dpy,dpz)+
      	      	 kvis*this.grid.diffV[i][j][k].crossTerm(i,j,k,this.v)+
      	      	 buoyant*trans.jacob*this.t[i][j][k];
      	  cf.setAdDf(uxp,uxm,vyp,vym,wzp,wzm,kvis,s,
      	      	     this.grid.diffV[i][j][k]);
      	  cf.setDt(trans.jacob*dti,this.v[i][j][k]);
      	  this.dv[i][j][k]=dinv*trans.dfveta/cf.ac;
      	  cf.setCenter();
      	}
      	else{
      	  cf.fix(this.v[i][j][k]);
      	  this.dv[i][j][k]=0;
      	}
      }
    }
  }
  this.setBCforV(this.flowBc);
  return this.vCondition.sor
    (1,this.grid.nx,1,this.grid.ny+1,1,this.grid.nz,this.v,this.coef);
};

// xzvZcԂ
FVMDataModel.prototype.calcW=function(){
  this.contraVarVel();
  var dti=this.param.dti;
  var kvis=this.param.kvis;
  var dinv=1/this.param.density;
  var buoyant=-this.param.beta*this.gravity.z;
  for(var i=1;i<this.grid.nx;i++){
    for(var j=1;j<this.grid.ny;j++){
      var uu1=this.uu[i][j],uu2=this.uu[i+1][j];
      var vv1=this.vv[i][j],vv2=this.vv[i][j+1];
      var ww1=this.ww[i][j];
      var p1=this.p[i-1][j],p3=this.p[i+1][j];
      var p21=this.p[i][j-1],p22=this.p[i][j],p23=this.p[i][j+1];
      for(var k=1;k<=this.grid.nz;k++){
      	var cf=this.coef[i][j][k];
      	if(isCalc(this.flowBc,i-1,j-1,k-1) ||
      	   isCalc(this.flowBc,i,j-1,k-1) ||
      	   isCalc(this.flowBc,i-1,j,k-1) ||
      	   isCalc(this.flowBc,i,j,k-1)){
      	  var uxp=0.5*(uu2[k-1]+uu2[k]);
      	  var uxm=0.5*(uu1[k-1]+uu1[k]);
      	  var vyp=0.5*(vv2[k-1]+vv2[k]);
      	  var vym=0.5*(vv1[k-1]+vv1[k]);
      	  var wzp=0.5*(ww1[k]+ww1[k+1]);
      	  var wzm=0.5*(ww1[k]+ww1[k-1]);
      	  var dpx=0.25*(p3[k-1]-p1[k-1]+p3[k]-p1[k]);
      	  var dpy=0.25*(p23[k-1]-p21[k-1]+p23[k]-p21[k]);
      	  var dpz=p22[k]-p22[k-1];
      	  var trans=this.grid.transW[i][j][k];
      	  var s=-dinv*trans.dpdz(dpx,dpy,dpz)+
      	      	 kvis*this.grid.diffW[i][j][k].crossTerm(i,j,k,this.w)+
      	      	 buoyant*trans.jacob*this.t[i][j][k];
      	  cf.setAdDf(uxp,uxm,vyp,vym,wzp,wzm,kvis,s,
      	      	     this.grid.diffW[i][j][k]);
      	  cf.setDt(trans.jacob*dti,this.w[i][j][k]);
      	  this.dw[i][j][k]=dinv*trans.dfwzeta/cf.ac;
      	  cf.setCenter();
      	}
      	else{
      	  cf.fix(this.w[i][j][k]);
      	  this.dw[i][j][k]=0;
      	}
      }
    }
  }
  this.setBCforW(this.flowBc);
  return this.wCondition.sor
    (1,this.grid.nx,1,this.grid.ny,1,this.grid.nz+1,this.w,this.coef);
};

// ͂vZcԂ
FVMDataModel.prototype.calcP=function(){
  this.contraVarVel();
  var i,j,k,dpp,nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(i=1;i<nx;i++){
    var vv1=this.vv[i],dv1=this.dv[i];
    for(j=1;j<ny;j++){
      var ww1=this.ww[i][j],dw1=this.dw[i][j];
      var cf=this.coef[i][j];
      for(k=1;k<nz;k++){
      	cf[k].set(this.du[i+1][j][k],this.du[i][j][k],dv1[j+1][k],
      	      	  dv1[j][k],dw1[k+1],dw1[k],
      	      	  this.uu[i+1][j][k]-this.uu[i][j][k]+vv1[j+1][k]-
      	      	  vv1[j][k]+ww1[k+1]-ww1[k]);
      	cf[k].setCenter();
      }
    }
  }
  for(i=0;i<=nx;i++){
    for(j=1;j<=ny;j++){
      dpp=this.dp[i][j];
      for(k=1;k<=nz;k++){
      	dpp[k]=0;
      }
    }
  }
  this.pCondition.sor(1,nx,1,ny,1,nz,this.dp,this.coef);
  for(j=1;j<ny;j++){
    for(k=1;k<nz;k++){
      this.dp[0][j][k]=this.dp[1][j][k];
      this.dp[nx][j][k]=this.dp[nx-1][j][k];
    }
  }
  for(i=0;i<=nx;i++){
    dpp=this.dp[i];
    for(k=1;k<nz;k++){
      dpp[0][k]=dpp[1][k];
      dpp[ny][k]=dpp[ny-1][k];
    }
  }
  for(i=0;i<=nx;i++){
    for(j=1;j<=ny;j++){
      dpp=this.dp[i][j];
      dpp[0]=dpp[1];
      dpp[nz]=dpp[nz-1];
    }
  }
  var dps=0,ps=0,dp0=this.dp[1][1][1];
  for(i=1;i<nx;i++){
    for(j=1;j<ny;j++){
      var pp=this.p[i][j];
      for(k=1;k<nz;k++){
      	dpp=this.dp[i][j][k];
      	pp[k]+=dpp-dp0;
      	dps+=Math.abs(dpp-dp0);
      	ps+=Math.abs(pp[k]);
      }
    }
  }
  this.setBCforC(this.flowBc,this.p,this.p0);
  if(ps===0) return dps;
  else       return dps/ps;
};

// ԑx玟̃Xebv̑xvZ
FVMDataModel.prototype.updateVel=function(){
  var i,j,k,duu,dvv,dww,du1,du2,dv1,dv2,dw1,dw2,dpx,dpy,dpz,dp1,dp2,dp3;
  var nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz,tr;
  for(i=1;i<=nx;i++){
    dp1=this.dp[i-1];
    dp2=this.dp[i];
    dv1=this.dv[i-1];
    dv2=this.dv[i];
    for(j=1;j<ny;j++){
      duu=this.du[i][j];
      dw1=this.dw[i-1][j];
      dw2=this.dw[i][j];
      tr=this.grid.transU[i][j];
      for(k=1;k<nz;k++){
      	dvv=0.25*(dv2[j][k]+dv1[j][k]+dv2[j+1][k]+dv1[j+1][k]);
      	dww=0.25*(dw2[k]+dw1[k]+dw2[k+1]+dw1[k+1]);
      	dpx=dp2[j][k]-dp1[j][k];
      	dpy=0.25*(dp1[j+1][k]-dp1[j-1][k]+dp2[j+1][k]-dp2[j-1][k]);
      	dpz=0.25*(dp1[j][k+1]-dp1[j][k-1]+dp2[j][k+1]-dp2[j][k-1]);
      	this.u[i][j][k]+=tr[k].vx(duu[k]*dpx,dvv*dpy,dww*dpz);
      }
    }
  }
  for(i=1;i<nx;i++){
    dp1=this.dp[i-1];
    dp2=this.dp[i];
    dp3=this.dp[i+1];
    du1=this.du[i];
    for(j=1;j<=ny;j++){
      dvv=this.dv[i][j];
      dw1=this.dw[i][j-1];
      dw2=this.dw[i][j];
      tr=this.grid.transV[i][j];
      for(k=1;k<nz;k++){
      	duu=0.25*(du1[j][k]+this.du[i+1][j][k]+
      	      	  du1[j-1][k]+this.du[i-1][j-1][k]);
      	dww=0.25*(dw2[k]+dw2[k+1]+dw1[k]+dw1[k+1]);
      	dpx=0.25*(dp3[j-1][k]-dp1[j-1][k]+dp3[j][k]-dp1[j][k]);
      	dpy=dp2[j][k]-dp2[j-1][k];
      	dpz=0.25*(dp2[j-1][k+1]-dp2[j-1][k-1]+dp2[j][k+1]-dp2[j][k-1]);
      	this.v[i][j][k]+=tr[k].vy(duu*dpx,dvv[k]*dpy,dww*dpz);
      }
    }
  }
  for(i=1;i<nx;i++){
    dp2=this.dp[i];
    for(j=1;j<ny;j++){
      dp1=this.dp[i-1][j];
      dp3=this.dp[i+1][j];
      du1=this.du[i][j];
      du2=this.du[i+1][j];
      dv1=this.dv[i][j];
      dv2=this.dv[i][j+1];
      dww=this.dw[i][j];
      tr=this.grid.transW[i][j];
      for(k=1;k<=nz;k++){
      	duu=0.25*(du1[k]+du1[k-1]+du2[k]+du2[k-1]);
      	dvv=0.25*(dv1[k]+dv1[k-1]+dv2[k]+dv2[k-1]);
      	dpx=0.25*(dp3[k-1]-dp1[k-1]+dp3[k]-dp1[k]);
      	dpy=0.25*(dp2[j+1][k-1]-dp2[j-1][k-1]+dp2[j+1][k]-dp2[j-1][k]);
      	dpz=dp2[j][k]-dp2[j][k-1];
      	this.w[i][j][k]+=tr[k].vz(duu*dpx,dvv*dpy,dww[k]*dpz);
      }
    }
  }
  this.setBCforU(this.flowBc);
  this.setBCforV(this.flowBc);
  this.setBCforW(this.flowBc);
};

// xvZcԂ
FVMDataModel.prototype.calcT=function(){
  this.contraVarVel();
  this.setBCforC(this.heatBc,this.t,this.t0);
  var dti=this.param.dti,alp=this.param.alpha;
  var nx=this.grid.nx,ny=this.grid.ny,nz=this.grid.nz;
  for(var i=1;i<nx;i++){
    for(var j=1;j<ny;j++){
      var uu1=this.uu[i+1][j],uu2=this.uu[i][j];
      var vv1=this.vv[i][j+1],vv2=this.vv[i][j],ww1=this.ww[i][j];
      var tr=this.grid.transP[i][j],diff=this.grid.diffP[i][j];
      for(var k=1;k<nz;k++){
      	var cf=this.coef[i][j][k];
      	cf.setAdDf(uu1[k],uu2[k],vv1[k],vv2[k],ww1[k+1],ww1[k],alp,0,
      	      	   diff[k]);
      	cf.setDt(tr[k].jacob*dti,this.t[i][j][k]);
      	cf.setCenter();
      }
    }
  }
  return this.tCondition.sor
    (1,nx,1,ny,1,nz,this.t,this.coef);
};

// iq_̑x̍őlԂ
FVMDataModel.prototype.getMaxV=function(){
  var vMax=0;
  for(var i=0;i<this.grid.nx;i++){
    var u1=this.u[i+1];
    var w1=this.w[i],w2=this.w[i+1];
    for(var j=0;j<this.grid.ny;j++){
      var v1=this.v[i][j+1],v2=this.v[i+1][j+1];
      for(var k=0;k<this.grid.nz;k++){
      	var ug=u1[j][k]+u1[j+1][k]+u1[j][k+1]+u1[j+1][k+1];
      	var vg=v1[k]+v1[k+1]+v2[k]+v2[k+1];
      	var wg=w1[j][k+1]+w1[j+1][k+1]+w2[j][k+1]+w2[j+1][k+1];
      	vMax=Math.max(vMax,ug*ug+vg*vg+wg*wg);
      }
    }
  }
  return 0.25*Math.sqrt(vMax);
};

// fʊiq_̑xԂ
FVMDataModel.prototype.getSectionV=function(){
  return this.section.atSectionV
    (this.grid.nx,this.grid.ny,this.grid.nz,this.u,this.v,this.w);
};

// fʊiq_̈͂Ԃ
FVMDataModel.prototype.getSectionPressure=function(){
  return this.section.atSectionPoint
    (this.grid.nx,this.grid.ny,this.grid.nz,this.p);
};

// fʊiq_̉xԂ
FVMDataModel.prototype.getSectionTemperature=function(){
  return this.section.atSectionPoint
    (this.grid.nx,this.grid.ny,this.grid.nz,this.t);
};

//--------------------------------------------------------------------//
// E

// E쐬
// nx,ny,nz - x,y,ziq_
function createBC(nx,ny,nz){
  var bc=[];
  for(var i=0;i<nx;i++){
    bc[i]=[];
    for(var j=0;j<ny;j++){
      bc[i][j]=[];
      for(var k=0;k<nz;k++){
      	bc[i][j][k]=NONE;
      }
    }
  }
  return bc;
}

// x+ʂ̋Eݒ肷
// bc - Ez
// bc0 - ݒ肷鋫E
function setBcXp(bc,bc0){
  var bcx=bc[bc.length-1];
  for(var j=0;j<bcx.length;j++){
    for(var k=0;k<bcx[j].length;k++){
      bcx[j][k]=bc0;
    }
  }
}

// x-ʂ̋Eݒ肷
// bc - Ez
// bc0 - ݒ肷鋫E
function setBcXm(bc,bc0){
  var bcx=bc[0];
  for(var j=0;j<bcx.length;j++){
    for(var k=0;k<bcx[j].length;k++){
      bcx[j][k]=bc0;
    }
  }
}

// y+ʂ̋Eݒ肷
// bc - Ez
// bc0 - ݒ肷鋫E
function setBcYp(bc,bc0){
  for(var i=0;i<bc.length;i++){
    var bcy=bc[i][bc[i].length-1];
    for(var k=0;k<bcy.length;k++){
      bcy[k]=bc0;
    }
  }
}

// y-ʂ̋Eݒ肷
// bc - Ez
// bc0 - ݒ肷鋫E
function setBcYm(bc,bc0){
  for(var i=0;i<bc.length;i++){
    var bcy=bc[i][0];
    for(var k=0;k<bcy.length;k++){
      bcy[k]=bc0;
    }
  }
}

// z+ʂ̋Eݒ肷
// bc - Ez
// bc0 - ݒ肷鋫E
function setBcZp(bc,bc0){
  for(var i=0;i<bc.length;i++){
    for(var j=0;j<bc[i].length;j++){
      var bcz=bc[i][j];
      bcz[bcz.length-1]=bc0;
    }
  }
}

// z-ʂ̋Eݒ肷
// bc - Ez
// bc0 - ݒ肷鋫E
function setBcZm(bc,bc0){
  for(var i=0;i<bc.length;i++){
    for(var j=0;j<bc[i].length;j++){
      bc[i][j][0]=bc0;
    }
  }
}

// X̕ӂɍvꍇ true
// bc - Ez
// i,j,k - x,y,zCfbNX
// condition - 
function bcX(bc,i,j,k,condition){
  var im=Math.max(i-1,0);
  return ((bc[im][j][k]==condition) || (bc[i][j][k]==condition));
}

// Y̕ӂɍvꍇ true
// bc - Ez
// i,j,k - x,y,zCfbNX
// condition - 
function bcY(bc,i,j,k,condition){
  var jm=Math.max(j-1,0);
  return ((bc[i][jm][k]==condition) || (bc[i][j][k]==condition));
}

// Z̕ӂɍvꍇ true
// bc - Ez
// i,j,k - x,y,zCfbNX
// condition - 
function bcZ(bc,i,j,k,condition){
  var km=Math.max(k-1,0);
  return ((bc[i][j][km]==condition) || (bc[i][j][k]==condition));
}

// X-Yʂɍvꍇ true
// bc - Ez
// i,j,k - x,y,zCfbNX
// condition - 
function bcXY(bc,i,j,k,condition){
  var im=Math.max(i-1,0),jm=Math.max(j-1,0);
  return ((bc[im][jm][k]==condition) || (bc[i][jm][k]==condition) ||
      	  (bc[im][j][k]==condition) || (bc[i][j][k]==condition));
}

// Y-Zʂɍvꍇ true
// bc - Ez
// i,j,k - x,y,zCfbNX
// condition - 
function bcYZ(bc,i,j,k,condition){
  var jm=Math.max(j-1,0),km=Math.max(k-1,0);
  return ((bc[i][jm][km]==condition) || (bc[i][j][km]==condition) ||
      	  (bc[i][jm][k]==condition) || (bc[i][j][k]==condition));
}

// Z-Xʂɍvꍇ true
// bc - Ez
// i,j,k - x,y,zCfbNX
// condition - 
function bcZX(bc,i,j,k,condition){
  var im=Math.max(i-1,0),km=Math.max(k-1,0);
  return ((bc[im][j][km]==condition) || (bc[i][j][km]==condition) ||
      	  (bc[im][j][k]==condition) || (bc[i][j][k]==condition));
}

// vZ̑ΏۂƂȂꍇ true
// bc - Ez
// i,j,k - x,y,zCfbNX
function isCalc(bc,i,j,k){
  return ((bc[i][j][k]===NONE) || (bc[i][j][k]===SLIP) ||
      	  (bc[i][j][k]===PERIODIC));
}

//--------------------------------------------------------------------//
// ̃p[^
// dt - ԍݕ
// iterMax - 񐔂̍ől
var FlowParameter=function(dt,iterMax){
  this.set(dt,iterMax);
  this.iter=0;		// 
  this.density=1;	// x
  this.vis=0;		// SW
  this.beta=0;		// ̐ϖc
  this.conduct=0;	// M`
  this.cp=1;		// 舳M
  this.kvis=0;		// SW
  this.alpha=0;		// MgUW
};

// p[^ݒ肷
// dt - ԍݕ
// iterMax - 񐔂̍ől
FlowParameter.prototype.set=function(dt,iterMax){
  this.dt=dt;
  if(dt<=0) this.dti=0;		// ԍݕ̋t
  else      this.dti=1/dt;
  this.iterMax=iterMax;
};

// 񐔂
FlowParameter.prototype.init=function(){
  this.iter=0;
};

// ̃Xebvɐi
FlowParameter.prototype.next=function(){
  this.iter++;
};

// vZꍇ true
FlowParameter.prototype.isFinished=function(){
  return (this.iter>=this.iterMax);
};

// 񐔕\Ԃ
FlowParameter.prototype.iteration=function(){
  return 'Step '+this.iter+'/'+this.iterMax;
};

// ޗp[^ݒ肷
// density - x
// vis - SW
// beta - ̐ϖc
// conduct - M`
// cp - 舳M
FlowParameter.prototype.setMaterial=function
  (density,vis,beta,conduct,cp){

  this.density=density;
  this.vis=vis;
  this.beta=beta;
  this.conduct=conduct;
  this.cp=cp;
  this.kvis=vis/density;
  this.alpha=conduct/(density*cp);
};

// vgԂ
FlowParameter.prototype.pandtl=function(){
  return this.kvis/this.alpha;
};

//--------------------------------------------------------------------//
// iq_|C^
var Pointer=function(){
  this.x=-1;
  this.y=-1;
  this.z=-1;
};

// |C^ݒ肷
// x,y,z - x,y,zCfbNX
Pointer.prototype.set=function(x,y,z){
  this.x=x;
  this.y=y;
  this.z=z;
};

// fʊiq_̑xԂ
// nx,ny,nz - x,y,ziq_
// u,v,w xx,y,zz
Pointer.prototype.atSectionV=function(nx,ny,nz,u,v,w){
  var vg=[[]],i,j,k,u1,u2,v1,v2,w1,w2;
  if(this.x>=0){
    w1=w[this.x];
    w2=w[this.x+1];
    for(j=0;j<ny;j++){
      vg[j]=[];
      u1=u[this.x+1][j];
      u2=u[this.x+1][j+1];
      v1=v[this.x][j+1];
      v2=v[this.x+1][j+1];
      for(k=0;k<nz;k++){
      	vg[j][k]=new THREE.Vector3
      	  (0.5*(u1[k]+u1[k+1]+u2[k]+u2[k+1]),
      	   0.5*(v1[k]+v1[k+1]+v2[k]+v2[k+1]),
      	   0.5*(w1[j][k+1]+w1[j+1][k+1]+w2[j][k+1]+w2[j+1][k+1]));
      }
    }
  }
  else if(this.y>=0){
    var y=this.y;
    for(i=0;i<nx;i++){
      vg[i]=[];
      u1=u[i+1][y];
      u2=u[i+1][y+1];
      v1=v[i][y+1];
      v2=v[i+1][y+1];
      w1=w[i];
      w2=w[i+1];
      for(k=0;k<nz;k++){
      	vg[i][k]=new THREE.Vector3
      	  (0.5*(u1[k]+u1[k+1]+u2[k]+u2[k+1]),
      	   0.5*(v1[k]+v1[k+1]+v2[k]+v2[k+1]),
      	   0.5*(w1[y][k+1]+w1[y+1][k+1]+w2[y][k+1]+w2[y+1][k+1]));
      }
    }
  }
  else if(this.z>=0){
    var z=this.z;
    for(i=0;i<nx;i++){
      vg[i]=[];
      u1=u[i+1];
      v1=v[i];
      v2=v[i+1];
      w1=w[i];
      w2=w[i+1];
      for(j=0;j<ny;j++){
      	vg[i][j]=new THREE.Vector3
      	  (0.5*(u1[j][z]+u1[j][z+1]+u1[j+1][z]+u1[j+1][z+1]),
      	   0.5*(v1[j+1][z]+v1[j+1][z+1]+v2[j+1][z]+v2[j+1][z+1]),
      	   0.5*(w1[j][z+1]+w1[j+1][z+1]+w2[j][z+1]+w2[j+1][z+1]));
      }
    }
  }
  return vg;
};

// fʊiq_̃p[^Ԃ
// nx,ny,nz - x,y,ziq_
// p iqS_̃p[^z
Pointer.prototype.atSectionPoint=function(nx,ny,nz,p){
  var pp=[[]],i,j,k,p1,p2,p3,p4;
  if(this.x>=0){
    for(j=0;j<ny;j++){
      pp[j]=[];
      p1=p[this.x][j];
      p2=p[this.x][j+1];
      p3=p[this.x+1][j];
      p4=p[this.x+1][j+1];
      for(k=0;k<nz;k++){
      	pp[j][k]=0.125*(p1[k]+p2[k]+p3[k]+p4[k]+
      	      	      	p1[k+1]+p2[k+1]+p3[k+1]+p4[k+1]);
      }
    }
  }
  else if(this.y>=0){
    for(i=0;i<nx;i++){
      pp[i]=[];
      p1=p[i][this.y];
      p2=p[i][this.y+1];
      p3=p[i+1][this.y];
      p4=p[i+1][this.y+1];
      for(k=0;k<nz;k++){
      	pp[i][k]=0.125*(p1[k]+p2[k]+p3[k]+p4[k]+
      	      	      	p1[k+1]+p2[k+1]+p3[k+1]+p4[k+1]);
      }
    }
  }
  else if(this.z>=0){
    var z=this.z;
    for(i=0;i<nx;i++){
      pp[i]=[];
      p1=p[i];
      p2=p[i+1];
      for(j=0;j<ny;j++){
      	pp[i][j]=0.125*(p1[j][z]+p1[j+1][z]+p2[j][z]+p2[j+1][z]+
      	      	      	p1[j][z+1]+p1[j+1][z+1]+p2[j][z+1]+
      	      	      	p2[j+1][z+1]);
      }
    }
  }
  return pp;
};

//--------------------------------------------------------------------//
// SOR@̌vZ
// iterMax - 񐔂̍ől
// relaxn- ɘaW
// theshold - 臒l
var SORCondition=function(iterMax,relax,theshold){
  this.iterMax=iterMax;
  this.relax=relax;
  this.theshold=theshold;
};

// SOR@ŌvZcԂ
// x1,x2 - xCfbNX͈̔
// y1,y2 - yCfbNX͈̔
// z1,z2 - zCfbNX͈̔
// p - p[^̔z
// coef - šW̔z
SORCondition.prototype.sor=function(x1,x2,y1,y2,z1,z2,p,coef){
  var err;
  for(var itr=0;itr<this.iterMax;itr++){
    err=0;
    var psum=0;
    for(var i=x1;i<x2;i++){
      var ci=coef[i],pi=p[i];
      for(var j=y1;j<y2;j++){
      	var cij=ci[j],pij=pi[j];
      	for(var k=z1;k<z2;k++){
      	  var dp=cij[k].next(i,j,k,p)-pij[k];
      	  pij[k]+=this.relax*dp;
      	  err+=Math.abs(dp);
      	  psum+=Math.abs(pij[k]);
      	}
      }
    }
    if(psum>0) err/=psum;
    if(err<this.theshold) return err;
  }
  return err;
};

//--------------------------------------------------------------------//
// Wϊs
// j1 - d/dx->d/d̕ϊs
var Transform=function(j1){
  if((j1===null) || (j1===undefined)){
    this.j1=[[],[],[]];
    this.j2=[[],[],[]];		// d/d->d/dxϊs
  }
  else{
    this.j1=j1;
    var j2=[[],[],[]];
    j2[0][0]=j1[1][1]*j1[2][2]-j1[1][2]*j1[2][1];
    j2[0][1]=j1[2][1]*j1[0][2]-j1[2][2]*j1[0][1];
    j2[0][2]=j1[0][1]*j1[1][2]-j1[0][2]*j1[1][1];
    j2[1][0]=j1[1][2]*j1[2][0]-j1[1][0]*j1[2][2];
    j2[1][1]=j1[2][2]*j1[0][0]-j1[2][0]*j1[0][2];
    j2[1][2]=j1[0][2]*j1[1][0]-j1[0][0]*j1[1][2];
    j2[2][0]=j1[1][0]*j1[2][1]-j1[1][1]*j1[2][0];
    j2[2][1]=j1[2][0]*j1[0][1]-j1[2][1]*j1[0][0];
    j2[2][2]=j1[0][0]*j1[1][1]-j1[0][1]*j1[1][0];
// RrAEt
    this.jacob=j1[0][0]*j2[0][0]+j1[0][1]*j2[1][0]+j1[0][2]*j2[2][0];
    this.jinv=1.0/this.jacob;
    for(var i=0;i<3;i++){
      for(var j=0;j<3;j++){
      	j2[i][j]*=this.jinv;
      }
    }
    this.j2=j2;
    var jacob2=this.jacob*this.jacob;
// W fÚEfVŁEfW
    this.dfuxsi=-jacob2*(j2[0][0]*j2[0][0]+j2[1][0]*j2[1][0]+
      	      	      	 j2[2][0]*j2[2][0]);
    this.dfveta=-jacob2*(j2[0][1]*j2[0][1]+j2[1][1]*j2[1][1]+
      	      	      	 j2[2][1]*j2[2][1]);
    this.dfwzeta=-jacob2*(j2[0][2]*j2[0][2]+j2[1][2]*j2[1][2]+
      	      	      	  j2[2][2]*j2[2][2]);
  }
};

// gUW c11 Ԃ
Transform.prototype.c11=function(){
  var j20=this.j2[0],j21=this.j2[1],j22=this.j2[2];
  return this.jacob*(j20[0]*j20[0]+j21[0]*j21[0]+j22[0]*j22[0]);
};

// gUW c22 Ԃ
Transform.prototype.c22=function(){
  var j20=this.j2[0],j21=this.j2[1],j22=this.j2[2];
  return this.jacob*(j20[1]*j20[1]+j21[1]*j21[1]+j22[1]*j22[1]);
};

// gUW c33 Ԃ
Transform.prototype.c33=function(){
  var j20=this.j2[0],j21=this.j2[1],j22=this.j2[2];
  return this.jacob*(j20[2]*j20[2]+j21[2]*j21[2]+j22[2]*j22[2]);
};

// gUW c12 Ԃ
Transform.prototype.c12=function(){
  var j20=this.j2[0],j21=this.j2[1],j22=this.j2[2];
  return this.jacob*(j20[0]*j20[1]+j21[0]*j21[1]+j22[0]*j22[1]);
};

// gUW c23 Ԃ
Transform.prototype.c23=function(){
  var j20=this.j2[0],j21=this.j2[1],j22=this.j2[2];
  return this.jacob*(j20[1]*j20[2]+j21[1]*j21[2]+j22[1]*j22[2]);
};

// gUW c31 Ԃ
Transform.prototype.c31=function(){
  var j20=this.j2[0],j21=this.j2[1],j22=this.j2[2];
  return this.jacob*(j20[2]*j20[0]+j21[2]*j21[0]+j22[2]*j22[0]);
};

// ϑx̃̐Ԃ
// u,v,w - xx,y,z
Transform.prototype.contraVx=function(u,v,w){
  return this.jacob*(this.j2[0][0]*u+this.j2[1][0]*v+this.j2[2][0]*w);
};

// ϑx̃ŐԂ
// u,v,w - xx,y,z
Transform.prototype.contraVy=function(u,v,w){
  return this.jacob*(this.j2[0][1]*u+this.j2[1][1]*v+this.j2[2][1]*w);
};

// ϑx̃ĐԂ
// u,v,w - xx,y,z
Transform.prototype.contraVz=function(u,v,w){
  return this.jacob*(this.j2[0][2]*u+this.j2[1][2]*v+this.j2[2][2]*w);
};

// xxԂ
// u,v,w - ϑx̃,,ĕ
Transform.prototype.vx=function(u,v,w){
  return this.jinv*(this.j1[0][0]*u+this.j1[1][0]*v+this.j1[2][0]*w);
};

// xyԂ
// u,v,w - ϑx̃,,ĕ
Transform.prototype.vy=function(u,v,w){
  return this.jinv*(this.j1[0][1]*u+this.j1[1][1]*v+this.j1[2][1]*w);
};

// xzԂ
// u,v,w - ϑx̃,,ĕ
Transform.prototype.vz=function(u,v,w){
  return this.jinv*(this.j1[0][2]*u+this.j1[1][2]*v+this.j1[2][2]*w);
};

//  dp/dx ݒ肷
// px,py,pz -  dp/d,dp/d,dp/d
Transform.prototype.dpdx=function(px,py,pz){
  var j20=this.j2[0];
  return this.jacob*(j20[0]*px+j20[1]*py+j20[2]*pz);
};

//  dp/dy ݒ肷
// px,py,pz -  dp/d,dp/d,dp/d
Transform.prototype.dpdy=function(px,py,pz){
  var j21=this.j2[1];
  return this.jacob*(j21[0]*px+j21[1]*py+j21[2]*pz);
};

//  dp/dz ݒ肷
// px,py,pz -  dp/d,dp/d,dp/d
Transform.prototype.dpdz=function(px,py,pz){
  var j22=this.j2[2];
  return this.jacob*(j22[0]*px+j22[1]*py+j22[2]*pz);
};

// WϊsԂ
// tr1,tr2 - QƂWϊs
function createTransform2(tr1,tr2){
  var tr=new Transform(null);
  tr.jacob=0.5*(tr1.jacob+tr2.jacob);
  tr.jinv=1/tr.jacob;
  for(var i=0;i<3;i++){
    for(var j=0;j<3;j++){
      tr.j1[i][j]=0.5*(tr1.j1[i][j]+tr2.j1[i][j]);
      tr.j2[i][j]=0.5*(tr1.j2[i][j]+tr2.j2[i][j]);
    }
  }
  tr.dfuxsi=0.5*(tr1.dfuxsi+tr2.dfuxsi);
  tr.dfveta=0.5*(tr1.dfveta+tr2.dfveta);
  tr.dfwzeta=0.5*(tr1.dfwzeta+tr2.dfwzeta);
  return tr;
}

// WϊsԂ
// tr1,tr2,tr3,tr4 - QƂWϊs
function createTransform4(tr1,tr2,tr3,tr4){
  var tr=new Transform(null);
  tr.jacob=0.25*(tr1.jacob+tr2.jacob+tr3.jacob+tr4.jacob);
  tr.jinv=1/tr.jacob;
  for(var i=0;i<3;i++){
    for(var j=0;j<3;j++){
      tr.j1[i][j]=0.25*(tr1.j1[i][j]+tr2.j1[i][j]+tr3.j1[i][j]+
      	      	      	tr4.j1[i][j]);
      tr.j2[i][j]=0.25*(tr1.j2[i][j]+tr2.j2[i][j]+tr3.j2[i][j]+
      	      	      	tr4.j2[i][j]);
    }
  }
  tr.dfuxsi=0.25*(tr1.dfuxsi+tr2.dfuxsi+tr3.dfuxsi+tr4.dfuxsi);
  tr.dfveta=0.25*(tr1.dfveta+tr2.dfveta+tr3.dfveta+tr4.dfveta);
  tr.dfwzeta=0.25*(tr1.dfwzeta+tr2.dfwzeta+tr3.dfwzeta+tr4.dfwzeta);
  return tr;
}

//--------------------------------------------------------------------//
// gǓW
var DiffusionCoef=function(){
  this.d=[[[0,0,0],[0,0,0],[0,0,0]],[[0,0,0],[0,0,0],[0,0,0]],
      	  [[0,0,0],[0,0,0],[0,0,0]]];
};

// Ԃ
// i,j,k - x,y,zCfbNX
// p - p[^̔z
DiffusionCoef.prototype.crossTerm=function(i,j,k,p){
  var d0=this.d[0],d1=this.d[1],d2=this.d[2];
  var pm=p[i-1],pc=p[i],pp=p[i+1];
  return d2[2][1]*pp[j+1][k]+d2[0][1]*pp[j-1][k]+d0[2][1]*pm[j+1][k]+
      	 d0[0][1]*pm[j-1][k]+d1[2][2]*pc[j+1][k+1]+
      	 d1[2][0]*pc[j+1][k-1]+d1[0][2]*pc[j-1][k+1]+
      	 d1[0][0]*pc[j-1][k-1]+d2[1][2]*pp[j][k+1]+d0[1][2]*pm[j][k+1]+
      	 d2[1][0]*pp[j][k-1]+d0[1][0]*pm[j][k-1];
};

//--------------------------------------------------------------------//
// šW
var MatrixCoef=function(){
  this.ac=0;	// SW
  this.axp=0;	// x+W
  this.axm=0;	// x-W
  this.ayp=0;	// y+W
  this.aym=0;	// y-W
  this.azp=0;	// z+W
  this.azm=0;	// z-W
  this.s=0;	// 
};

// Wݒ肷
// uxp,uxm - x+,x-x
// vyp,vym - y+,y-x
// wzp,wzm - z+,z-x
// alpha - gUW
// s - 
// d - gǓW
MatrixCoef.prototype.setAdDf=function(uxp,uxm,vyp,vym,wzp,wzm,alpha,s,d){
  var dd=d.d,dd1=dd[1],abs=Math.abs,max=Math.max;
  this.axp=max(0.5*abs(uxp),alpha*dd[2][1][1])-0.5*uxp;
  this.axm=max(0.5*abs(uxm),alpha*dd[0][1][1])+0.5*uxm;
  this.ayp=max(0.5*abs(vyp),alpha*dd1[2][1])-0.5*vyp;
  this.aym=max(0.5*abs(vym),alpha*dd1[0][1])+0.5*vym;
  this.azp=max(0.5*abs(wzp),alpha*dd1[1][2])-0.5*wzp;
  this.azm=max(0.5*abs(wzm),alpha*dd1[1][0])+0.5*wzm;
  this.ac=this.axp+this.axm+this.ayp+this.aym+this.azp+this.azm+
      	  uxp-uxm+vyp-vym+wzp-wzm;
  this.s=s;
};

// lŒ肷
// s - 
// s - Œ肷l
MatrixCoef.prototype.fix=function(s){
  this.ac=1;
  this.axp=0;
  this.axm=0;
  this.ayp=0;
  this.aym=0;
  this.azp=0;
  this.azm=0;
  this.s=s;
};

// Wݒ肷
// axp,axm - x+,x-W
// ayp,aym - y+,y-W
// azp,azm - z+,z-W
// s - 
MatrixCoef.prototype.set=function(axp,axm,ayp,aym,azp,azm,s){
  this.axp=axp;
  this.axm=axm;
  this.ayp=ayp;
  this.aym=aym;
  this.azp=azp;
  this.azm=azm;
  this.ac=axp+axm+ayp+aym+azp+azm;
  this.s=s;
};

// ԍݕݒ肷
// jdt - J/t
// p - ̃p[^l
MatrixCoef.prototype.setDt=function(jdt,p){
  this.ac+=jdt;
  this.s+=jdt*p;
};

// SWݒ肷
MatrixCoef.prototype.setCenter=function(){
  var acInv=1/this.ac;
  this.ac=1.0;
  this.axp*=acInv;
  this.axm*=acInv;
  this.ayp*=acInv;
  this.aym*=acInv;
  this.azp*=acInv;
  this.azm*=acInv;
  this.s*=acInv;
};

// KEX=UCf@Ŏ̃Xebv̒lԂ
// i,j,k - Sx,y,zCfbNX
// p - p[^̃Xg
MatrixCoef.prototype.next=function(i,j,k,p){
  var pi=p[i],pij=pi[j];
  return this.axp*p[i+1][j][k]+this.axm*p[i-1][j][k]+
      	 this.ayp*pi[j+1][k]+this.aym*pi[j-1][k]+
      	 this.azp*pij[k+1]+this.azm*pij[k-1]+this.s;
};
